<?php 
/************************************************************************************************
* Ceiboo News v1908 es desarrollado y mantenido por Ceiboo.com
*
* @author José Luis Alfaro <joseluis@ceiboo.com>
* @link http://dev.ceiboo.com/
* @copyright Copyright &copy; 2007-2019 ceiboo.com
* @version  v1908
* @package  TControl
* 
*************************************************************************************************/
Class TControl extends TObject {

	public $TSession = NULL;
	public $TError = NULL;
	public $TResponse = NULL;
	public $TUpload = NULL;
	public $TView = NULL;
	public $TWords = NULL;
	public $TShare = NULL;
	public $TDb = NULL;

	public $bSessionIniciada=NULL;
	public $VarConfig=NULL;
	
	public function __construct() { 
	}
	
	/**
	* Inicializa las constantes (paths) principales y 
	* llamo a  startFramework() para arrancar el mismo.
	* @param none;
	*	<code>
	*		self::$TControl->TControl->start();
	* </code>
	*/
	public function start()
	{
		/* arranco la aplicacion */
		$this->TRoute = new TRoute($this);
		$aRoute=$this->TRoute->route();
		
		define("_TB_APP",$aRoute["app"]);
		define("_TB_SUBSITE",$aRoute["controller"]);
		
		$this->startFramework();
		$this->startConfig();
		$this->startMysql();
		$this->TInfo->startInfo();
		
		$this->TRoute->routeApp($aRoute);

	}


	/**
	* Este metodo es el encargado de levantar las librerias necesarias para
	* el funcionamiento de la framework y tambien es el encargado de
	* arrancar la apliacion. 
	* @param none;
	*	<code>
	*		self::$TControl->TControl->startFramework();
	* </code>
	*/
	public function startFramework()
	{
		/* instancio librias del core */
		$this->TSession = new TSession($this);
		$this->TResponse = new TResponse($this);
		$this->TRequest = new TRequest($this);
      	$this->TError = new TError($this);
		$this->TUpload = new TUpload($this);
		$this->TView = new TView($this);
		$this->TUtil = new TUtil($this);
		$this->TWords = new TWords($this);
		$this->TFormat = new TFormat($this);
		$this->TShare = new TShare($this);
		$this->TJson = new TJson($this);
		$this->TInfo = new TInfo($this);

	}

	public function startConfig()
	{
		require_once _TB_PATHMIDDLEWARE."includes/ceiboo.paths.php";
		require_once _TB_PATHMIDDLEWARE."includes/ceiboo.config.php";
		require_once _TB_PATHMIDDLEWARE."includes/ceiboo.libs.php";
	}
	
	public function startMysql()
	{

		$this->VarConfig = ceibooConfig();
		$this->TDbconnect = new TDbconnect($this);
		$this->TDb = $this->TDbconnect->init();

		ceibooLibs($this);
	}


}
?>
