<?php
/**
* TDbconnect.php 
*
* Es la clase que provee la conexion con la base de datos.
*
* @author José Luis Alfaro <joseluis@tbackend.com.ar>
* @link http://www.tbackend.com.ar/
* @copyright Copyright &copy; 2009 ceiboo.com
* @since     Versión 3.0, revisión 20090601.
* @version   3.0
* @package TDb
*/
class TDbConnect //extends TObject
	{

		static private $TControl=NULL;
		
		public function __construct(TControl $TControl)
			{
				self::$TControl = $TControl;
			}
	
		function exinit($dbtype = 'mysqli', $fileconfig='conector.php' , $modules = '' )
		{
			require_once _TB_PATH3RDPARTY.'adodb52/adodb.inc.php';

			$db = adoNewConnection('mysqli'); # eg. 'mysqli' or 'oci8'
			$db->debug = true;
			$db->connect(self::$TControl->VarConfig["dbhost"], self::$TControl->VarConfig["dbuser"], self::$TControl->VarConfig["dbpassword"], self::$TControl->VarConfig["dbdatabase"]);
			return $db;
		}

		/**
		* private function init()
		* Inicializa la classe tdbconnect.
		* @param   string  $dbtype      Define el tipo de base de datos.
		* @param   string  $fileconfig      Define el archivo que hace de conector.
		* @param   string  $modules      Modulos, se inicializa vacio.
		*/
		function init($dbtype = 'mysqlt', $fileconfig='conector.php' , $modules = '' )
			{
				global $ADODB_FETCH_MODE;
				
				require_once _TB_PATH3RDPARTY."adodb_lite/adodb.inc"._TB_EXT;

				$false = false;
				if($dbtype == 'mysqlt' || $dbtype == 'mysqli')
				{
					@include( ADODB_DIR . '/conectores/'. $fileconfig);
				} 

				if (strpos($dbtype,'://'))
					{
						$dsn_array = @parse_url(rawurldecode($dbtype));

						if (!$dsn_array || !$dsn_array['scheme']) { return $false; }
						
						$dbtype = $dsn_array['scheme'];
						$modules = (!empty($dsn_array['fragment'])) ? $dsn_array['fragment'] : $modules;
					} else { 
						$dsn_array = array('scheme'=>''); 
					}

				$dbtype = strtolower($dbtype);
				include_once ADODB_DIR . '/adodbSQL_drivers/' . $dbtype . '/' . $dbtype . '_driver.inc';
				$last_module = $dbtype . '_' . 'driver';
				if(!empty($modules))
					{
						$module_list = explode(":", strtolower($modules));
						$generic_modules = array();
						foreach($module_list as $mod) 
							{
								$mod = trim($mod);
								if(is_file(ADODB_DIR . '/generic_modules/' . $mod . '_module.inc'))
									{
										$generic_modules[] = $mod;
									} else {
										include_once ADODB_DIR . '/adodbSQL_drivers/' . $dbtype . '/' . $dbtype . '_' . $mod . '_module.inc';
										$last_module = $dbtype . '_' . $mod;
									}
							}
				
						if(count($generic_modules))
							{
								foreach($generic_modules as $mod) 
									{
										include_once ADODB_DIR . '/generic_modules/' . $mod . '_module.inc';
										$last_module = $mod;
									}
							}
					}

				$extention = $last_module . '_ADOConnection';
			
				$object = new $extention();
				$object->last_module_name = $last_module;
				$object->raiseErrorFn = (defined('ADODB_ERROR_HANDLER')) ? ADODB_ERROR_HANDLER : false;
				$object->query_count = 0;
				$object->query_time_total = 0;

				if(!empty($dsn_array['scheme']))
					{
						if (isset($dsn_array['port'])) { $object->port = $dsn_array['port']; }
						$persistent = false;
						$forcenew = false;
	  					if (isset($dsn_array['query'])) 
	  						{
								$option_array = explode('&', $dsn_array['query']);
								foreach($option_array as $element => $value) 
									{
										$array = explode('=', $value);
										$data = isset($array[1]) ? $array[1] : 1;
											switch(strtolower($array[0])) 
												{
													case 'persist':
													case 'persistent':
														$persistent = $data;
														break;
													case 'debug':
														$object->debug = (integer) $data;
														break;
													case 'fetchmode':
														$ADODB_FETCH_MODE = constant($data);
														break;
													case 'clientflags':
														$object->clientFlags = $data;
														break;
													case 'port':
														$object->port = $data;
														break;
													case 'socket':
														$object->socket = $data;
														break;
													case 'forcenew':
														$forcenew = $data;
														break;
												}
									}
							}
						$dsn_array['host'] = isset($dsn_array['host']) ? $dsn_array['host'] : '';
						$dsn_array['user'] = isset($dsn_array['user']) ? $dsn_array['user'] : '';
						$dsn_array['pass'] = isset($dsn_array['pass']) ? $dsn_array['pass'] : '';
						$dsn_array['path'] = isset($dsn_array['path']) ? substr($dsn_array['path'], 1) : '';
				
						$result = $object->_connect($dsn_array['host'], $dsn_array['user'], $dsn_array['pass'], $dsn_array['path'], $persistent, $forcenew);
						if (!$result) { echo "No puedo conectar la DB en "; var_dump($dsn_array);
							return $false; }
					}
				return $object;
			}
	}

?>