<?php
/**
* TJson.php 
*
* 	Es la clase que lee y graba archivos Json
*
* @author José Luis Alfaro <joseluis@ceiboo.com>
* @link http://www.ceiboo.com/
* @copyright Copyright &copy; 2007-2018 ceiboo.com
* @version  10.0 
* @package TJson
*/

Class TJson
{ 
   static private $TControl=NULL;

   public function __construct(TControl $TControl)
   {
      self::$TControl = $TControl;
   }

   public function writeContent($file_name,$data_array)
   {
      try 
      {
         if ((array) $data_array !== $data_array) {
               throw new Exception('Invalid data_array');
         }
         $eJson=json_encode($data_array,JSON_UNESCAPED_SLASHES);
         // Append to File
         /*if (json_last_error() !== JSON_ERROR_NONE) {
            throw new Exception('Invalid JSON File Format');
         }*/
         file_put_contents($file_name, $eJson);
      } catch (Exception $ex) {
         echo static::exceptionCaught($ex);
      }
   }

   public function readContent($file_name)
   {
      $file_content = file_get_contents($file_name);
      try 
      {
            if ($file_content === false) {
               return [];
            }

            $json_content = json_decode($file_content, true);

            if ($json_content === null && json_last_error() !== JSON_ERROR_NONE) {
               throw new Exception('Invalid JSON File Format');
            }
            // Valid Data or empty
            return ($json_content === null) ? [] : $json_content;
      } catch (Exception $ex) {
            echo static::exceptionCaught($ex);
      }
   }    
} 
?>
