<?php
/************************************************************************************************
* Ceiboo News v1908 es desarrollado y mantenido por Ceiboo.com
*
* @author José Luis Alfaro <joseluis@ceiboo.com>
* @link http://dev.ceiboo.com/
* @copyright Copyright &copy; 2007-2019 ceiboo.com
* @version  v1908
* @package  TRoute
* 
*************************************************************************************************/

Class TRoute
{
	static private $TControl=NULL;
	
	public function __construct(TControl $TControl)
	{
		self::$TControl = $TControl;
	}

	public function route() 
	{
		$aRoute=[];
		// Exploto el dominio
		$aSubdomains=explode('.', $_SERVER['HTTP_HOST']);
		
		// Si no hay subdominio interpreto que es www
		if(count($aSubdomains)<3)
		{
			$aSubdomains[2]=$aSubdomains[1];
			$aSubdomains[1]=$aSubdomains[0];
			$aSubdomains[0]="www";
		}
		$sSubdominio=$aSubdomains[0];
		$sDominio=$aSubdomains[1];
		$sExtension=$aSubdomains[2];
		
		// Si el dominio es ceiboo, esta entrando al CORE o al WS
		if($sDominio=="posthree")
		{
			if($sSubdominio=="www")
			{
				$aRoute["app"]="posthree";
				$aRoute["pathcontroller"]=_TB_PATHMIDDLEWARE."apps/posthree/controllers/";
				$aRoute["controller"]="posthree";
			}
		} else {
			if($sSubdominio=="www")
			{
				$aRoute["pathcontroller"]=_TB_PATHMIDDLEWARE."apps/"._TB_APP."/site/controllers/";
				$aRoute["app"]=_TB_APP;
				$aRoute["controller"]="site";
			} elseif($sSubdominio=="admin") {
				$aRoute["pathcontroller"]=_TB_PATHMIDDLEWARE."apps/"._TB_APP."/admin/controllers/";
				$aRoute["app"]=_TB_APP;
				$aRoute["controller"]="admin";
			}
		}
		
		if($sExtension=="jla") {
			define('_TB_ENTORNO', "local");
			error_reporting(E_ALL ^ E_NOTICE);
			ini_set("display_errors", "1");
		} else {
				define('_TB_ENTORNO', "online");
				error_reporting(0);
				ini_set("display_errors", "0");
		}
		
		return $aRoute;

	}

	public function routeApp($aRoute)
	{
		$sPath = (isset($_GET["ruta"]) ? $_GET["ruta"] : '' );
		$sPath = ((substr($sPath,-1)=='/') ? substr($sPath,0,-1) : $sPath);
		$aPaths = (!empty($sPath)) ? explode("/", $sPath) : array();

		self::$TControl->TSession->start();

		
				
		switch(count($aPaths))
		{
			case 0:
				$aRoute["action"]="startController";				
				break;
			case 1:
				$aPaths[0]=str_replace("-","_",$aPaths[0]);
				if(is_file($aRoute["pathcontroller"].$aPaths[0]._TB_EXT))
				{
					$aRoute["controller"]=$aPaths[0];
					$aRoute["action"]="startController";
				} else {
					$aRoute["action"]=$aPaths[0];
				}
				array_shift($aPaths);
				break;

			default:
				$aPaths[0]=str_replace("-","_",$aPaths[0]);
				if(is_file($aRoute["pathcontroller"].$aPaths[0]._TB_EXT))
				{
					$aPaths[1]=str_replace("-","_",$aPaths[1]);
					$aRoute["controller"]=$aPaths[0];
					$aRoute["action"]=$aPaths[1];
					array_shift($aPaths);
				} else {
					$aRoute["action"]=$aPaths[0];
				}
				array_shift($aPaths);
				
				break;
				
		}
		
		self::runController($aRoute, $aPaths);
	}

	public function runController($aRoute, $aPaths)
	{
		$sClassName = 'TController' . ucwords($aRoute["controller"]);
		
		if(is_file($aRoute["pathcontroller"].$aRoute["controller"]._TB_EXT))
		{
			require_once $aRoute["pathcontroller"].$aRoute["controller"]._TB_EXT;
			$oClass = new ReflectionClass($sClassName);
			$aArguments[] = self::$TControl;
			$oControllerInstance = $oClass->newInstanceArgs($aArguments);
			$aObjFunction=array($sClassName, $aRoute["action"]);
			foreach($aRoute as $key => $rRoute)
			{
				$aPaths[$key]=$aRoute[$key];
			}
			//			$aPaths["controller"]=$aRoute["controller"];
			//			$aPaths["action"]=$aRoute["action"];
			
			if(is_callable($aObjFunction))
			{
				if(is_null($aPaths))
				{
					return call_user_func($aObjFunction, null);
				} else {
					call_user_func($aObjFunction, $aPaths);
				}
			} else {
				die("No se puedo ejecutar la funcion ( ".$aRoute["action"]." ), en ".$aRoute["pathcontroller"].$aRoute["controller"]._TB_EXT." puede que no exista.");
			} 
		} else {
			
			die("El controlador ( ".$aRoute["controller"]." ) no existe en ".$aRoute["pathcontroller"]);
		}

	}


}
?>