<?php
/**
* TUpload.php 
*
* 	Es la clase que TUpload.
*
* @author José Luis Alfaro <joseluis@ceiboo.com>
* @link http://www.ceiboo.com/
* @copyright Copyright &copy; 2010 ceiboo.com
* @since     Versión 4.0, revisión 20100901
* @version   4.0
* @package TUpload
*/

Class TUpload
{ 
    static private $TControl=NULL;
    public $aAttribVerotNormalSize=NULL;
    public $aAttribVerotBigSize=NULL;
    static private $aAttribVerotFacebookSize=NULL;
    public $sPathInApp="upload/images/";
    static private $sPathFacebookInApp="upload/fb/";

    public function __construct(TControl $TControl)
    {
        self::$TControl = $TControl;
        $this->aAttribVerotNormalSize = array("image_x"=>450,"image_y"=>300, "image_resize"=>true, "image_ratio_crop"=>true );
        $this->aAttribVerotBigSize = array("image_x"=>1200,"image_y"=>800, "image_resize"=>true, "image_ratio_crop"=>true );
        self::$aAttribVerotFacebookSize = array("image_x"=>600,"image_y"=>400, "image_resize"=>true, "image_ratio_crop"=>true );
        require_once _TB_PATHBASE.'engine/3rdparty/class.upload.php';
    }

    public function UploadPDF($source,$target)
    {

        if ($_FILES[$source]['type'] == "application/pdf") 
        {
            $result = move_uploaded_file($_FILES[$source]['tmp_name'], _TB_PATHAPP.$target);
            /*if ($result == 1) echo "<p>Upload done .</p>";
            else echo "<p>Sorry, Error happened while uploading . </p>";*/
            
         } 
    }

    public function UploadFile($source,$target)
    {
        move_uploaded_file($_FILES[$source]['tmp_name'], _TB_PATHAPP.$target);
        chmod(_TB_PATHAPP.$target, 0777);
    }

    public function setPath($path)
    {
        $this->sPathInApp=$path;
    }

    public function setBigSize($aSize)
    {
        $this->aAttribVerotBigSize=$aSize;
    }

    public function setNormalSize($aSize)
    {
        $this->aAttribVerotNormalSize=$aSize;
    }

    public function UploadDirectImageFromUrl($sUrlFile="",$sufix="b", $tmp=false)
    {
        $data = file_get_contents($sUrlFile);
        $sPath=(($tmp)?$tmp:$this->sPathInApp);
        $exploded = explode('/', $sUrlFile);
        $extension = explode('.', end($exploded));
        $original=str_replace(' ','_',strtolower(_TB_WEBTITLE))."_".$sufix.".".end($extension);
        $file_new_name_body=_TB_PATHAPP.$sPath.$original;
        file_put_contents($file_new_name_body, $data);
        chmod($file_new_name_body, 0777);
        return $sPath.$original;
    }

/*  
* Metodo encargado de devolver los restaurantes para su listado
*/
    public function UploadImage($sInputFile="imagen",$sFileName="")
    {
        
        $sPath=_TB_PATHUPLOAD.$this->sPathInApp;
        $sNameSufix=uniqid();
        $aAttribVerotNormalSize=$this->aAttribVerotNormalSize;
        $aAttribVerotBigSize=$this->aAttribVerotBigSize;
        
        if($_FILES[$sInputFile]["name"]!='')
        {
            $aFileName=explode(".",$_FILES[$sInputFile]["name"]);
            // creo un variable que apunta al archivo
            $handle = new Upload($_FILES[$sInputFile]);
            if($handle->uploaded)
            {
                
                // BIG SIZE
                if($aAttribVerotBigSize) 
                {
                    
                    $handle->file_new_name_body=str_replace(' ','_',strtolower(_TB_WEBTITLE))."_".$sFileName."__b__".$sNameSufix;
                    foreach($aAttribVerotBigSize as $key => $rAttribVerot)
                    {

                        if(substr($key,0,6)=='image_')
                        {
                            $index=$key;
                            if($rAttribVerot===true) {
                                $handle->$key=true;
                            } elseif($rAttribVerot===false) {
                                $handle->$key=false;
                            } else {
                                $handle->$key=$rAttribVerot;
                            }
                        }
                    }

                    $handle->Process($sPath);
                    if ($handle->processed)
                    {
                        
                        $original = $handle->file_dst_name;
                        chmod($sPath.$original, 0777);
                    }

                }

                // SMALL SIZE
                if($aAttribVerotNormalSize) 
                {
                    $handle->file_new_name_body=str_replace(' ','_',strtolower(_TB_WEBTITLE))."_".$sFileName."__n__".$sNameSufix;
                    foreach($aAttribVerotNormalSize as $key => $rAttribVerot)
                    {

                        if(substr($key,0,6)=='image_')
                        {
                            $index=$key;
                            if($rAttribVerot===true) {
                                $handle->$key=true;
                            } elseif($rAttribVerot===false) {
                                $handle->$key=false;
                            } else {
                                $handle->$key=$rAttribVerot;
                            }
                        }
                    }

                    $handle->Process($sPath);
                    if ($handle->processed)
                    {
                        $original = $handle->file_dst_name;
                        chmod($sPath.$original, 0777);
                        return $this->sPathInApp.urlencode($original);
                    } else {
                        die("__error__".$handle->error);
                        return "__error__".$handle->error;
                    }
                    $handle-> Clean();
                } else {
                    die("__error__".$handle->error);
                    return "__error__".$handle->error;
                }
            } else {
                die("__error__".$handle->error);
                return "__error__NO HAY ARCHIVO";
            }
            die("__error__".$handle->error);
            return "__error__UFF";
        }
    }

/*  
* Metodo encargado de devolver los restaurantes para su listado
*/
    public function UploadImageFromUrl($sUrl,$sFileName="",$tmp="upload/tmp/")
    {
        $sImagen=self::UploadDirectImageFromUrl($sUrl,"b_".uniqid(),$tmp);
        $pathImagen=_TB_PATHAPP.$sImagen;
        $sPath=_TB_PATHAPP.$this->sPathInApp;
        $sNameSufix=uniqid();
        $aAttribVerotNormalSize=self::$aAttribVerotNormalSize;
        $aAttribVerotBigSize=self::$aAttribVerotBigSize;
        if($pathImagen!='')
        {
            $aFileName=explode(".",$pathImagen);
            // creo un variable que apunta al archivo
            $handle = new Upload($pathImagen);
            if($handle->uploaded)
            {
                // BIG SIZE
                if($aAttribVerotBigSize) 
                {
                    $handle->file_new_name_body=str_replace(' ','_',strtolower(_TB_WEBTITLE))."_".$sFileName."__b__".$sNameSufix;
                    //echo $handle->file_new_name_body;
                    foreach($aAttribVerotBigSize as $key => $rAttribVerot)
                    {

                        if(substr($key,0,6)=='image_')
                        {
                            $index=$key;
                            if($rAttribVerot===true) {
                                $handle->$key=true;
                            } elseif($rAttribVerot===false) {
                                $handle->$key=false;
                            } else {
                                $handle->$key=$rAttribVerot;
                            }
                        }
                    }

                    $handle->Process($sPath);
                    if ($handle->processed)
                    {
                        $original = $handle->file_dst_name;
                        //echo "<br> >>> ".$original;
                        chmod($sPath.$original, 0777);
                    }
                }

                // SMALL SIZE
                if($aAttribVerotNormalSize) 
                {
                    $handle->file_new_name_body=str_replace(' ','_',strtolower(_TB_WEBTITLE))."_".$sFileName."__n__".$sNameSufix;
                    foreach($aAttribVerotNormalSize as $key => $rAttribVerot)
                    {

                        if(substr($key,0,6)=='image_')
                        {
                            $index=$key;
                            if($rAttribVerot===true) {
                                $handle->$key=true;
                            } elseif($rAttribVerot===false) {
                                $handle->$key=false;
                            } else {
                                $handle->$key=$rAttribVerot;
                            }
                        }
                    }

                    $handle->Process($sPath);
                    if ($handle->processed)
                    {
                        $original = $handle->file_dst_name;
                        chmod($sPath.$original, 0777);
                        return $this->sPathInApp.urlencode($original);
                    } else {
                        return "__error__".$handle->error;
                    }
                    $handle-> Clean();
                } else {
                    return "__error__".$handle->error;
                }
            } else {
                return "__error__NO HAY ARCHIVO";
            }
            return "__error__UFF";
        }
    }


    public function UploadImageFromFacebook($sUrl,$sFileName="",$tmp="upload/tmp/")
    {
        $sImagen=self::UploadDirectImageFromUrl($sUrl,"fb_".uniqid(),$tmp);
        $pathImagen=_TB_PATHAPP.$sImagen;
        $sPath=_TB_PATHAPP.self::$sPathFacebookInApp;
        $sNameSufix=uniqid();
        $aAttribVerotFacebookSize=self::$aAttribVerotFacebookSize;
        if($pathImagen!='')
        {
            $aFileName=explode(".",$pathImagen);
            // creo un variable que apunta al archivo
            $handle = new Upload($pathImagen);
            if($handle->uploaded)
            {

                // SMALL SIZE
                if($aAttribVerotFacebookSize) 
                {
                    $handle->file_new_name_body=str_replace(' ','_',strtolower(_TB_WEBTITLE))."_".$sFileName."__fb__".$sNameSufix;
                    $handle->file_new_name_ext = 'jpg';
                    foreach($aAttribVerotFacebookSize as $key => $rAttribVerot)
                    {

                        if(substr($key,0,6)=='image_')
                        {
                            $index=$key;
                            if($rAttribVerot===true) {
                                $handle->$key=true;
                            } elseif($rAttribVerot===false) {
                                $handle->$key=false;
                            } else {
                                $handle->$key=$rAttribVerot;
                            }
                        }
                    }

                    $handle->Process($sPath);
                    if ($handle->processed)
                    {
                        $original = $handle->file_dst_name;
                        chmod($sPath.$original, 0777);
                        return self::$sPathFacebookInApp.urlencode($original);
                    } else {
                        return "__error__".$handle->error;
                    }
                    $handle-> Clean();
                } else {
                    return "__error__".$handle->error;
                }
            } else {
                return "__error__NO HAY ARCHIVO";
            }
            return "__error__UFF";
        }
    }

}   
?>
