<?php
Class tUtil
{
    
    static private $TControl=NULL;
 
    public function __construct(TControl $TControl)
    {
       self::$TControl = $TControl;
    }
    public function actualUrl()
    {
        return $_SERVER["REQUEST_SCHEME"]."://".$_SERVER["HTTP_HOST"].$_SERVER["REQUEST_URI"];
    }
    public function myhash()
    {
        $h=[];      
        $h["REMOTE_ADDR"]=$_SERVER["REMOTE_ADDR"];
        $h["HTTP_CONNECTION"]=$_SERVER["HTTP_CONNECTION"];
        $h["REMOTE_PORT"]=$_SERVER["REMOTE_PORT"];
        $h["HTTP_USER_AGENT"]=$_SERVER["HTTP_USER_AGENT"];
        $code='';
        foreach ($h as $value) {
            $code.=$value;
        }
        return code;
    }
    
    public function titularEnMinusculas($string) 
    { 
        $tildes_MAYU=array("Á","É","Í","Ó","Ú","Ñ");
        $tildes_MINU=array("á","é","í","ó","ú","ñ");
        $string = str_replace($tildes_MAYU, $tildes_MINU, $string);
        $string=strtolower($string);
        $sentences = preg_split('/([.?!:]+)/', $string, -1, PREG_SPLIT_NO_EMPTY|PREG_SPLIT_DELIM_CAPTURE); 
        $new_string = ''; 
        foreach ($sentences as $key => $sentence) { 
            $new_string .= ($key & 1) == 0? 
                ucfirst(strtolower(trim($sentence))) : 
                $sentence.' '; 
        } 
        return trim($new_string); 
    } 
    
    public function acortaFecha($fecha) 
    {
        //$fecha=$this->sanear_string($fecha);
        $fecha=strtolower($fecha);
        $dias_BLANK_TILDES = array("","","","","","");
        $dias_ES_TILDES = array("miércoles","sábado","mi&eacute;rcoles","s&aacute;bado",".",":");
        $dias_BLANK = array("", "", "", "", "", "", "");
        $dias_ES = array("lunes", "martes", "miercoles", "jueves", "viernes", "sabado", "domingo");
        $dias_ES_SHORT = array("lun", "mar", "mie", "jue", "vie", "sab", "dom");
        $dias_EN = array("monday", "tuesday", "wednesday", "thursday", "friday", "saturday", "dunday");
        $meses_BLANK = array("Ene", "Feb", "Mar", "Abr", "May", "Jun", "Jul", "Ago", "Set", "Set", "Oct", "Nov", "Dic");
        $meses_ES = array("enero", "febrero", "marzo", "abril", "mayo", "junio", "julio", "agosto", "septiembre", "setiembre", "octubre", "noviembre", "diciembre");
        $meses_EN = array("january", "february", "march", "april", "may", "june", "july", "august", "september", "setember", "october", "november", "december");
        $anios_LARGOS = array("2018","2019","2020","2021","2022","2023","2024","2025");
        $anios_CORTOS = array("18","19","20","21","22","23","24","25");
        
        $fecha = str_replace($meses_EN, $meses_BLANK, $fecha);
        $fecha = str_replace($meses_ES, $meses_BLANK, $fecha);
        $fecha = str_replace($dias_ES_TILDES, $dias_BLANK_TILDES, $fecha);
        $fecha = str_replace($dias_ES, $dias_BLANK, $fecha);
        $fecha = str_replace($dias_ES_SHORT, $dias_BLANK, $fecha);
        $fecha = str_replace($dias_EN, $dias_BLANK, $fecha);
        $fecha = str_replace($anios_LARGOS, $anios_CORTOS, $fecha);
        $fecha = str_replace(" de ", "-", $fecha);
        $fecha = str_replace("de", "-", $fecha);
        $fecha = str_replace("publicado el", "", $fecha);
        $fecha = str_replace(",", "", $fecha);
        $fecha = trim($fecha);
        return $fecha;
    }


    public function formatFecha($fecha) 
    {
        $fecha = substr($fecha, 0, 10);
        $numeroDia = date('d', strtotime($fecha));
        $dia = date('l', strtotime($fecha));
        $mes = date('F', strtotime($fecha));
        $anio = date('Y', strtotime($fecha));
        $dias_ES = array("Lunes", "Martes", "Miércoles", "Jueves", "Viernes", "Sábado", "Domingo");
        $dias_EN = array("Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday", "Sunday");
        $nombredia = str_replace($dias_EN, $dias_ES, $dia);
        $meses_ES = array("Enero", "Febrero", "Marzo", "Abril", "Mayo", "Junio", "Julio", "Agosto", "Septiembre", "Octubre", "Noviembre", "Diciembre");
        $meses_EN = array("January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December");
        $nombreMes = str_replace($meses_EN, $meses_ES, $mes);
        return $nombredia.", ".$numeroDia." de ".$nombreMes." de ".$anio;
    }


    public function formatFechayHora($fecha,$saltar=false) 
    {
        //$fecha = substr($fecha, 0, 10);
        $numeroDia = date('d', strtotime($fecha));
        $dia = date('l', strtotime($fecha));
        $mes = date('F', strtotime($fecha));
        $anio = date('Y', strtotime($fecha));
        $dias_ES = array("Lun", "Mar", "Mie", "Jue", "Vie", "Sab", "Dom");
        $dias_EN = array("Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday", "Sunday");
        $nombredia = str_replace($dias_EN, $dias_ES, $dia);
        $meses_ES = array("Ene", "Feb", "Mar", "Abr", "May", "Jun", "Jul", "Ago", "Set", "Oct", "Nov", "Dic");
        $meses_EN = array("January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December");
        $nombreMes = str_replace($meses_EN, $meses_ES, $mes);
        $nuevafecha=$nombredia.", ".$numeroDia."/".$nombreMes."/".$anio;
        $nuevahora=date('H', strtotime($fecha)).":".date('i', strtotime($fecha))." hs.";
        if($saltar) 
        {
            return $nuevafecha."<br>".$nuevahora;
        } else {
            return $nuevafecha." ".$nuevahora;
        }
    }


    public function translateFecha($fecha)
    {
        $dias_ES = array("lunes", "martes", "miércoles", "miÃ©rcoles", "jueves", "viernes", "sábado", "sÃ¡bado", "domingo");
        $dias_EN = array("Monday", "Tuesday", "Wednesday", "Wednesday", "Thursday", "Friday", "Saturday", "Saturday", "Sunday");
        $meses_ES = array("enero", "febrero", "marzo", "abril", "mayo", "junio", "julio", "agosto", "septiembre", "octubre", "noviembre", "diciembre");
        $meses_EN = array("January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December");
        $fecha = strtolower($fecha);
        $fecha = str_replace($dias_ES, $dias_EN, $fecha);
        $fecha = str_replace($meses_ES, $meses_EN, $fecha);
        return $fecha;
    }

    public function formatFechaCorta($fecha) 
    {
        $fecha = substr($fecha, 0, 10);
        $numeroDia = date('d', strtotime($fecha));
        $dia = date('l', strtotime($fecha));
        $mes = date('F', strtotime($fecha));
        $anio = date('Y', strtotime($fecha));
        $dias_ES = array("Lun", "Mar", "Mie", "Jue", "Vie", "Sab", "Dom");
        $dias_EN = array("Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday", "Sunday");
        $nombredia = str_replace($dias_EN, $dias_ES, $dia);
        $meses_ES = array("Ene", "Feb", "Mar", "Abr", "May", "Jun", "Jul", "Ago", "Set", "Oct", "Nov", "Dic");
        $meses_EN = array("January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December");
        $nombreMes = str_replace($meses_EN, $meses_ES, $mes);
        return $nombredia.", ".$numeroDia." ".$nombreMes;
    }

    public function formatDiferencia($fecha) 
    {
        $fecha1 = new DateTime($fecha);
        $fecha2 = new DateTime();
        $intervalo = $fecha1->diff($fecha2);

        return array("largo" => $intervalo->format('%d dias %H horas %i minutos'),"horas" => ($intervalo->h + ($intervalo->days*24)));
    }

    public function url_to_absolute( $baseUrl, $relativeUrl )
    {
        // If relative URL has a scheme, clean path and return.
        $r = $this->split_url( $relativeUrl );
        if ( $r === FALSE )
            return FALSE;
        if ( !empty( $r['scheme'] ) )
        {
            if ( !empty( $r['path'] ) && $r['path'][0] == '/' )
                $r['path'] = $this->url_remove_dot_segments( $r['path'] );
            return $this->join_url( $r );
        }
    
        // Make sure the base URL is absolute.
        $b = $this->split_url( $baseUrl );
        if ( $b === FALSE || empty( $b['scheme'] ) || empty( $b['host'] ) )
            return FALSE;
        $r['scheme'] = $b['scheme'];
    
        // If relative URL has an authority, clean path and return.
        if ( isset( $r['host'] ) )
        {
            if ( !empty( $r['path'] ) )
                $r['path'] = $this->url_remove_dot_segments( $r['path'] );
            return $this->join_url( $r );
        }
        unset( $r['port'] );
        unset( $r['user'] );
        unset( $r['pass'] );
    
        // Copy base authority.
        $r['host'] = $b['host'];
        if ( isset( $b['port'] ) ) $r['port'] = $b['port'];
        if ( isset( $b['user'] ) ) $r['user'] = $b['user'];
        if ( isset( $b['pass'] ) ) $r['pass'] = $b['pass'];
    
        // If relative URL has no path, use base path
        if ( empty( $r['path'] ) )
        {
            if ( !empty( $b['path'] ) )
                $r['path'] = $b['path'];
            if ( !isset( $r['query'] ) && isset( $b['query'] ) )
                $r['query'] = $b['query'];
            return $this->join_url( $r );
        }
    
        // If relative URL path doesn't start with /, merge with base path
        if ( $r['path'][0] != '/' )
        {
            $base = mb_strrchr( $b['path'], '/', TRUE, 'UTF-8' );
            if ( $base === FALSE ) $base = '';
            $r['path'] = $base . '/' . $r['path'];
        }
        $r['path'] = $this->url_remove_dot_segments( $r['path'] );
        return $this->join_url( $r );
    }

    public function url_remove_dot_segments( $path )
    {
        // multi-byte character explode
        $inSegs  = preg_split( '!/!u', $path );
        $outSegs = array( );
        foreach ( $inSegs as $seg )
        {
            if ( $seg == '' || $seg == '.')
                continue;
            if ( $seg == '..' )
                array_pop( $outSegs );
            else
                array_push( $outSegs, $seg );
        }
        $outPath = implode( '/', $outSegs );
        if ( $path[0] == '/' )
            $outPath = '/' . $outPath;
        // compare last multi-byte character against '/'
        if ( $outPath != '/' &&
            (mb_strlen($path)-1) == mb_strrpos( $path, '/', 'UTF-8' ) )
            $outPath .= '/';
        return $outPath;
    }

    public function join_url( $parts, $encode=TRUE )
    {
        if ( $encode )
        {
            if ( isset( $parts['user'] ) )
                $parts['user']     = rawurlencode( $parts['user'] );
            if ( isset( $parts['pass'] ) )
                $parts['pass']     = rawurlencode( $parts['pass'] );
            if ( isset( $parts['host'] ) &&
                !preg_match( '!^(\[[\da-f.:]+\]])|([\da-f.:]+)$!ui', $parts['host'] ) )
                $parts['host']     = rawurlencode( $parts['host'] );
            if ( !empty( $parts['path'] ) )
                $parts['path']     = preg_replace( '!%2F!ui', '/',
                    rawurlencode( $parts['path'] ) );
            if ( isset( $parts['query'] ) )
                $parts['query']    = rawurlencode( $parts['query'] );
            if ( isset( $parts['fragment'] ) )
                $parts['fragment'] = rawurlencode( $parts['fragment'] );
        }

        $url = '';
        if ( !empty( $parts['scheme'] ) )
            $url .= $parts['scheme'] . ':';
        if ( isset( $parts['host'] ) )
        {
            $url .= '//';
            if ( isset( $parts['user'] ) )
            {
                $url .= $parts['user'];
                if ( isset( $parts['pass'] ) )
                    $url .= ':' . $parts['pass'];
                $url .= '@';
            }
            if ( preg_match( '!^[\da-f]*:[\da-f.:]+$!ui', $parts['host'] ) )
                $url .= '[' . $parts['host'] . ']';	// IPv6
            else
                $url .= $parts['host'];			// IPv4 or name
            if ( isset( $parts['port'] ) )
                $url .= ':' . $parts['port'];
            if ( !empty( $parts['path'] ) && $parts['path'][0] != '/' )
                $url .= '/';
        }
        if ( !empty( $parts['path'] ) )
            $url .= $parts['path'];
        if ( isset( $parts['query'] ) )
            $url .= '?' . $parts['query'];
        if ( isset( $parts['fragment'] ) )
            $url .= '#' . $parts['fragment'];
        return $url;
    }

    public function split_url( $url, $decode=TRUE )
    {
        // Character sets from RFC3986.
        $xunressub     = 'a-zA-Z\d\-._~\!$&\'()*+,;=';
        $xpchar        = $xunressub . ':@%';

        // Scheme from RFC3986.
        $xscheme        = '([a-zA-Z][a-zA-Z\d+-.]*)';

        // User info (user + password) from RFC3986.
        $xuserinfo     = '((['  . $xunressub . '%]*)' .
                        '(:([' . $xunressub . ':%]*))?)';

        // IPv4 from RFC3986 (without digit constraints).
        $xipv4         = '(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3})';

        // IPv6 from RFC2732 (without digit and grouping constraints).
        $xipv6         = '(\[([a-fA-F\d.:]+)\])';

        // Host name from RFC1035.  Technically, must start with a letter.
        // Relax that restriction to better parse URL structure, then
        // leave host name validation to application.
        $xhost_name    = '([a-zA-Z\d-.%]+)';

        // Authority from RFC3986.  Skip IP future.
        $xhost         = '(' . $xhost_name . '|' . $xipv4 . '|' . $xipv6 . ')';
        $xport         = '(\d*)';
        $xauthority    = '((' . $xuserinfo . '@)?' . $xhost .
                    '?(:' . $xport . ')?)';

        // Path from RFC3986.  Blend absolute & relative for efficiency.
        $xslash_seg    = '(/[' . $xpchar . ']*)';
        $xpath_authabs = '((//' . $xauthority . ')((/[' . $xpchar . ']*)*))';
        $xpath_rel     = '([' . $xpchar . ']+' . $xslash_seg . '*)';
        $xpath_abs     = '(/(' . $xpath_rel . ')?)';
        $xapath        = '(' . $xpath_authabs . '|' . $xpath_abs .
                '|' . $xpath_rel . ')';

        // Query and fragment from RFC3986.
        $xqueryfrag    = '([' . $xpchar . '/?' . ']*)';

        // URL.
        $xurl          = '^(' . $xscheme . ':)?' .  $xapath . '?' .
                        '(\?' . $xqueryfrag . ')?(#' . $xqueryfrag . ')?$';


        // Split the URL into components.
        if ( !preg_match( '!' . $xurl . '!', $url, $m ) )
            return FALSE;

        if ( !empty($m[2]) )		$parts['scheme']  = strtolower($m[2]);

        if ( !empty($m[7]) ) {
            if ( isset( $m[9] ) )	$parts['user']    = $m[9];
            else			$parts['user']    = '';
        }
        if ( !empty($m[10]) )		$parts['pass']    = $m[11];

        if ( !empty($m[13]) )		$h=$parts['host'] = $m[13];
        else if ( !empty($m[14]) )	$parts['host']    = $m[14];
        else if ( !empty($m[16]) )	$parts['host']    = $m[16];
        else if ( !empty( $m[5] ) )	$parts['host']    = '';
        if ( !empty($m[17]) )		$parts['port']    = $m[18];

        if ( !empty($m[19]) )		$parts['path']    = $m[19];
        else if ( !empty($m[21]) )	$parts['path']    = $m[21];
        else if ( !empty($m[25]) )	$parts['path']    = $m[25];

        if ( !empty($m[27]) )		$parts['query']   = $m[28];
        if ( !empty($m[29]) )		$parts['fragment']= $m[30];

        if ( !$decode )
            return $parts;
        if ( !empty($parts['user']) )
            $parts['user']     = rawurldecode( $parts['user'] );
        if ( !empty($parts['pass']) )
            $parts['pass']     = rawurldecode( $parts['pass'] );
        if ( !empty($parts['path']) )
            $parts['path']     = rawurldecode( $parts['path'] );
        if ( isset($h) )
            $parts['host']     = rawurldecode( $parts['host'] );
        if ( !empty($parts['query']) )
            $parts['query']    = rawurldecode( $parts['query'] );
        if ( !empty($parts['fragment']) )
            $parts['fragment'] = rawurldecode( $parts['fragment'] );
        return $parts;
    }

    public function rel2Abs($sRel,$sAbs, $page)
    {
        $Processed = false;
        $Errors = $Messages = array();
        $sAbs=stripslashes(trim($sAbs));
        $sRel=stripslashes(trim($sRel));

        if( empty($sAbs) or empty($sRel) )
        {
            $Errors[] = 'Both the base URL and the web page file name need to be provided.';
        }
        if( ! preg_match('!^https?://.!',$sAbs) )
        {
            $Errors[] = 'The base URL needs to be an http://... or https://... URL.';
        }
        if( ! file_exists($sRel) )
        {
            $Errors[] = "The file {$sRel} doesn't exist in the directory where this software is running.";
        }
        if( ! count($Errors) )
        {
            /*$page = '';
            if( ! ($page = file_get_contents($sRel)) )
            {
                $Errors[] = "Unable to read file {$sRel}";
                return;
            }*/
            preg_match_all('!src=[\'"]?([^\'"\s]*)!si',$page,$src);
            foreach( $src[1] as $item )
            {
                if( preg_match('!^[a-zA-Z]+\:!',$item) ) { continue; }
                if( preg_match('!^\#\?!',$item) ) { continue; }
                extract(parse_url($sAbs));
                if( strpos($item,'/')===0 ) { $path = ''; }
                if( $path ) { $path = preg_replace('!/[^/]*$!','',$path); }
                $abs = "$host$path/$item";
                while( preg_match('!/\w+/\.\./!',$abs) ) { $abs = preg_replace('!/\w+/\.\./!','/',$abs,1); }
                $abs = preg_replace('!/\.{0,2}/!','/',$abs);
                $item = preg_quote($item,'/');
                $page = preg_replace("!src=(['\"])?$item!i","src=\$1$scheme://$abs",$page);
            }
            preg_match_all('!href=[\'"]?([^\'"\s]*)!si',$page,$href);
            foreach( $href[1] as $item )
            {
                if( preg_match('!^[a-zA-Z]+\:!',$item) ) { continue; }
                if( preg_match('!^\#\?!',$item) ) { continue; }
                extract(parse_url($sAbs));
                if( strpos($item,'/')===0 ) { $path = ''; }
                if( $path ) { $path = preg_replace('!/[^/]*$!','',$path); }
                $abs = "$host$path/$item";
                while( preg_match('!/\w+/\.\./!',$abs) ) { $abs = preg_replace('!/\w+/\.\./!','/',$abs,1); }
                $abs = preg_replace('!/\.{0,2}/!','/',$abs);
                $item = preg_quote($item,'/');
                $page = preg_replace("!href=(['\"])?$item!i","href=\$1$scheme://$abs",$page);
            }

            /*if( file_put_contents($sRel,$page) )
            {
                $Messages[] = "Webpage file {$sRel} has been processed and updated.";
                $Processed = true;
            }
            else
            {
                $Errors[] = "Unable to update the file {$sRel}";
            }*/
        }
    }


}
?>




<?php
