<?php 
/**
* TView.php
*/

class TView
{
	static private $TControl=NULL;
	
	public function __construct(TControl $TControl)
	{
		self::$TControl = $TControl;
	}	

	
	/**
	 * Abre un archivo de vista public.
	 * @param string $sId Es el nombre del archivo.
	 * @param string $sModule si se necesita abrir desde un modulo especial.
	 * <code>
	 * 	self::$TControl->TView->openView($sValue);
	 * </code>
	 * return true;
	 */				
	public function openView($sId, $sPathAux = false)
	{
		$sPathAux = (!$sPathAux) ? _TB_PATHSITEVIEWS : $sPathAux;
		$bIsFileOpened=($sFilename=self::open($sPathAux . $sId . ".php"));
		if($bIsFileOpened) { 
			require_once $sFilename; 
		} else { 
			//echo 'No existe '.$sFilename.' o no se definió el Template en Index o es incorrecto el template: ';
			exit(0);
			//return false; 
		}
		return true;
	}

	public function openCache($sId, $sPathAux = false)
	{
		$bIsFileOpened=($sFilename=self::open(self::$TControl->TSites->getPathCacheHome() . $sId . ".php"));
		if($bIsFileOpened) { require_once $sFilename; } else { echo "No pude abrir: ".$bIsFileOpened; return false; }
		return true;
	}

	public function openGeneric($sId, $sPathAux = false)
	{
		$bIsFileOpened=($sFilename=self::open(_TB_PATHSITEVIEWSGENERIC . $sId . ".php"));
		if($bIsFileOpened) { require_once $sFilename; } else { return false; }
		return true;
	}

	public function openFlexible($sId, $sPathAux = false)
	{
		$bIsFileOpened=($sFilename=self::open(_TB_PATHSITEVIEWS . $sId . ".php"));
		if($bIsFileOpened) { 
			require_once $sFilename; 
		} else { 
			$bIsFileOpened=($sFilename=self::open(_TB_PATHVIEWSFLEXIBLE . $sId . ".php"));
			if($bIsFileOpened) { 
				require_once $sFilename; 
			} else { 
				return false; 
			}
		}
		return true;
	}

    public function openBackView($sId, $sPathAux = false)
	{
		$bIsFileOpened=($sFilename=self::open(_TB_PATHSITEVIEWSBACKEND . $sId . ".php"));
		if($bIsFileOpened) { require_once $sFilename; } else { return false; }
		return true;
	}

    public function getBlock($sId, $sPathAux = false)
	{
		$sPathAux = (!$sPathAux) ? _TB_PATHSITEVIEWS : $sPathAux;
		return file_get_contents($sPathAux . $sId . ".php");
	}

	public function getBackBlock($sId)
	{
		return file_get_contents(_TB_PATHSITEVIEWSBACKEND . $sId . ".php");
	}
		
	/**
	 * Abre un archivo de vista.
	 * @param string $sPath Es la ruta del archivo.
	 * <code>
	 * 	self::$TControl->TView->openFile($sPath);
	 * </code>
	 * return true;
	 */			
	public function openFile($sPath=false)
	{
		if($sPath)
		{
			if($sFilename=self::open($sPath))
			{
				require_once $sFilename;
			}
		} else {
			return false;
		}
	}

	public function open($sFilename)
	{
		if(is_file($sFilename))
		{
			return $sFilename;
		} else {
			return false;
		}
	}
		
	/**
	* Ejecuta una funcion y permite pasarle parametros a la misma
	* @param string $nombre      Nombre de la funcion
	* @param string $parametro0      Nombre del parametro 0
	* @param string $parametro1      Nombre del parametro 1
	* @param string $parametro2     Nombre del parametro 2
	*	<code>
	*			$TControl->TView->Execute($nombre, $parametro0,  $parametro1, $parametro2)
	* </code>
	* @return Retorna la funcion, con los parametros posteriormente pasados.
	*/
	public function Execute($nombre, $parametro0=null,  $parametro1=null, $parametro2=null , $parametro3=null, $parametro4=null, $parametro5=null )
	{

		if(is_null($parametro0))
		{ 
			return  call_user_func($nombre, self::$TControl); 
		} 
		elseif(is_null($parametro1))
		{
			return  call_user_func($nombre, self::$TControl, $parametro0);
		}
		elseif(is_null($parametro2)) 
		{
			return  call_user_func($nombre, self::$TControl, $parametro0, $parametro1); 
		}
		elseif(is_null($parametro3))
		{
			return  call_user_func($nombre, self::$TControl, $parametro0, $parametro1,$parametro2); 
		}
		elseif(is_null($parametro4))
		{
			return  call_user_func($nombre, self::$TControl, $parametro0, $parametro1,$parametro2,$parametro3); 
		}
		elseif(is_null($parametro5))
		{
			return  call_user_func($nombre, self::$TControl, $parametro0, $parametro1,$parametro2,$parametro3,$parametro4); 
		}
		else
		{
			return  call_user_func($nombre, self::$TControl, $parametro0, $parametro1,$parametro2,$parametro3,$parametro4,$parametro5); 
		}
	}
			
}	
?>
