<?php
require_once ("access.php");
Class TControllerAdmin extends TControllerAccess
{
	static private $TControl=NULL;
	static public $bigControl=NULL;
	
	public function __construct(TControl $TControl)
	{
		parent::__construct($TControl);
		self::$TControl = $TControl;
		self::$bigControl=array("minisidebar"=>false);
	}

	/**
	 *
	 * StartController es la función inicial si no hay parametros que ejecuta el Framework
	 *
	 */
	static public function startController($aParam=false)
	{
		parent::startController($aParam=false);

		if(self::$TControl->TLoggedon->isLogin())
		{
			self::homeAdmin();
		} else {
			parent::startController($aParam=false);
		} 
	}	

	static public function webmail()
	{	
		if(!self::$TControl->TLoggedon->isLogin()) { self::startController(); return false; }

		// Enable RainLoop Api and include index file 
		$_ENV['RAINLOOP_INCLUDE_AS_API'] = true;
		if(_TB_ENTORNO=="local") {
			include '/home/server/production/branches/joseluis/rainloop/index.php';
			$ssoHash = \RainLoop\Api::GetUserSsoHash('joseluis@ceiboo.com', 'ayd352008$MJ');
		} else {
			include '/home/server/published/sipemu/rainloop/index.php';
			$ssoHash = \RainLoop\Api::GetUserSsoHash('joseluis@ceiboo.com', 'ayd352008$MJ');
		}


		self::$TControl->TView->openView("adminhead");
		self::$TControl->TView->Execute("adminhead",self::$bigControl);
		self::$TControl->TView->openView("adminleft");
		self::$TControl->TView->Execute("adminleft");
		
		self::$TControl->TView->openView("adminnav");
		self::$TControl->TView->Execute("adminnav","webmail");

		self::$TControl->TView->openView("webmail");
		self::$TControl->TView->Execute("webmail",$ssoHash);

		self::$TControl->TView->openView("adminfooter");
		self::$TControl->TView->Execute("adminfooter",array("calculateH"));
		
		// redirect to webmail sso url
		// header('Location: http://webmail.larroque.jla/?sso&hash='.$ssoHash);
	}

	static public function homeAdmin()
	{	
		if(!self::$TControl->TLoggedon->isLogin()) { self::startController(); return false; }

		self::$TControl->TView->openView("adminhead");
		self::$TControl->TView->Execute("adminhead",self::$bigControl);
		self::$TControl->TView->openView("adminleft");
		self::$TControl->TView->Execute("adminleft");
		
		self::$TControl->TView->openView("adminnav");
		self::$TControl->TView->Execute("adminnav");
		$bigData=[];
		$bigData["news"]=self::$TControl->TPosts->getLasts(4);

		self::$TControl->TView->openView("shownews");
		self::$TControl->TView->Execute("shownews",$bigData);

		self::$TControl->TView->openView("adminfooter");
		self::$TControl->TView->Execute("adminfooter",array("calculateH"));
	}
	
	static public function listar($aParam=false)
	{
		if(!self::$TControl->TLoggedon->isLogin()) { self::startController(); return false; }

		$table=$aParam[0];
		$tableInstance="T".ucwords($table);
		$TInstance=self::$TControl->$tableInstance;
		
		self::$TControl->TView->openView("adminhead");
		self::$TControl->TView->Execute("adminhead",self::$bigControl);
		self::$TControl->TView->openView("adminleft");
		self::$TControl->TView->Execute("adminleft",$table);
		
		self::$TControl->TView->openView("adminnav");
		self::$TControl->TView->Execute("adminnav");

		$bigData=array("table" => $table, "data" => $TInstance->getList(), "instance" => $TInstance);

		self::$TControl->TView->openView("managerlist");
		self::$TControl->TView->Execute("managerlist",$bigData);
		self::$TControl->TView->openView("adminfooter");
		self::$TControl->TView->Execute("adminfooter",array("managerlist"));
	}

	static public function insertar($aParam=false)
	{
		$table=$aParam[0];
		self::editar($aParam);
	}	
	
	static public function editar($aParam=false)
	{
		if(!self::$TControl->TLoggedon->isLogin()) { self::startController(); return false; } 
		$table=$aParam[0];
		$tableInstance="T".ucwords($table);
		$TInstance=self::$TControl->$tableInstance;
		$bigData=$TInstance->getDataPack($aParam);
		$nav=isset($aParam["nav"])?$aParam["nav"]:'';
		if(isset($bigData["footer"]))
		{
			$aFooterScripts=$bigData["footer"];
		} else {
			$aFooterScripts=array("editor","dropify");
		}
		self::$TControl->TView->openView("adminhead");
		self::$TControl->TView->Execute("adminhead",self::$bigControl);
		self::$TControl->TView->openView("adminleft");
		self::$TControl->TView->Execute("adminleft",$table);
		
		$formTop=self::$TControl->TView->getBlock("managerformtop");
		$formBottom=self::$TControl->TView->getBlock("managerformbottom");

		self::$TControl->TView->openView("adminnav");
		self::$TControl->TView->Execute("adminnav",$nav);

		$action=isset($aParam["redirect"])?$aParam["redirect"]:$table;
		$formTop = str_replace("[action]", $action, $formTop);	
		$formTop = str_replace("[host]", _TB_HOSTADMIN, $formTop);
		$message=isset($aParam["message"])?$aParam["message"]:(isset(self::$TControl->TInfo->get($table)["translate"])?self::$TControl->TInfo->get($table)["translate"]:'');
		$formTop = str_replace("[message]", $message, $formTop);
		
		if(isset($aParam["inputs"])) 
		{
			$formTop .= $aParam["inputs"];
		}
		
		$form=isset($aParam["form"])?$aParam["form"]:"form".$table;
		self::$TControl->TView->openView($form);
		self::$TControl->TView->Execute($form,$bigData,$formTop,$formBottom);

		self::$TControl->TView->openView("adminfooter");
		self::$TControl->TView->Execute("adminfooter",$aFooterScripts);
	}


	/**
	 * @method guardar 		Almacena los datos de un formulario
	 *
	 * @since 2019.01
	 *
	 * @param array $aParam	Parametros de la ruta. 
	 * 						ej: http://admin.ceiboo.com/guardar/posts/
	 * 						trae el parametro "posts" en $aParam[0] que indica el nombre de la tabla (clase)
	 * 						en la que vamos a almacenar los datos del formulario
	 * 
	 * @param array $_GET	Datos del formulario
	 * 
	 * @return location 	Redirige al listado de datos. (Datatable)
	 */
	static public function guardar($aParam=false)
	{
		if(!self::$TControl->TLoggedon->isLogin()) { self::startController(); return false; } 
		$table=$aParam[0];

		if(isset($_GET["ajax"]) && ($table=="repository" || $table=="posts"))
		{
			self::guardarPostyRepo($aParam);
			return true;
		} 

		$tableInstance="T".ucwords($table);
		$TInstance=self::$TControl->$tableInstance;
		$TInstance->set($_POST);
		if(isset($_GET["redirect"])) {
			header("Location: "._TB_HOSTADMIN.$_GET["redirect"]);	
		} else {
			header("Location: "._TB_HOSTADMIN."listar/".$table."/");
		}
	}
	
	static public function ajaxManager($aParam=false)
	{
		if(!self::$TControl->TLoggedon->isLogin()) { echo "error de session"; return false; } 

		$sAction=$aParam[0];

		$sTable=$aParam[1];
		$sTableInstance="T".ucwords($sTable);
		$TInstance=self::$TControl->$sTableInstance;
		if (isset($_POST["id"])) 
		{
			switch ($sAction) {
				case 'remove':
					$TInstance->delete($_POST["id"]);		
					break;
				case 'switch':
					$TInstance->switchField($_POST["id"],$_POST["field"],$_POST["value"]);
					break;
				case 'getPost': 
					$aData=self::$TControl->TPosts->getByKey($_POST["id"]);
					$aData[0]["description"]=$aData[0]["description"];
					self::$TControl->TResponse->show($aData[0]);
					return true;
				default:
					echo "error de accion";
					return false;
					break;
			}
			
		}
		return true;
	}

	static public function ajaxFiles($aParam=false)
	{
		$search=$aParam[1];
		$action=$aParam[0];
		$aDatos=[];
		switch($action) {
			case "webimages":
				$aDatos=self::$TControl->TSpider->getImagesFromWebsite($_POST["url"]);
				break;
			case "googleimages":
				$aData=self::$TControl->TRequest->getArrayData("https://www.googleapis.com/customsearch/v1?key=AIzaSyBSLpSxcICriIP7i79a-mThzxOmhaE_bfM&cx=016348947976637328357:vbmmh8srnwm&q=".urlencode($search)."&searchType=image&imgSize=xxlarge&imgType=photo&rights=cc_publicdomain,cc_attribute,cc_sharealike");
				foreach($aData["items"] as $rDataImage) 
				{
                    $aDatos[]= array('imageUrl' =>$rDataImage['link'], 'name' => $rDataImage['title'], 'value' => $rDataImage['link']);
                }

				break;
			case "youtubevideo":
				$aData=self::$TControl->TRequest->getArrayData("https://www.googleapis.com/youtube/v3/search?key=AIzaSyBSLpSxcICriIP7i79a-mThzxOmhaE_bfM&part=snippet&order=date&maxResults=20&q=".urlencode($search));
				foreach ($aData["items"] as $rDataImage) 
				{
                    $fecha=substr($rDataImage['snippet']['publishedAt'],0,10);
                    $aDatos[]= array('imageUrl' => $rDataImage['snippet']['thumbnails']['medium']['url'], 'name' => $rDataImage['snippet']['title']." - ".$fecha, 'value' => $rDataImage['id']['videoId']);
                }
				break;
			case "trends":
				$aData=self::$TControl->TPosts->get("idtrend = '".urlencode($search)."'","0,20");
				foreach ($aData as $rData) 
				{
                    $fecha=substr($rData['published'],0,10);
					$aDatos[]= array('imageUrl' => $rData['image'], 'name' => $rData['title']." - ".$fecha, 
					'value' => self::$TControl->TPosts->formatUrl($rData['idpost'],$rData['title']));
                }
				break;
			case "categories":
				$aData=self::$TControl->TPosts->get("idcategory = '".urlencode($search)."'","0,20");
				foreach ($aData as $rData) 
				{
                    $fecha=substr($rData['published'],0,10);
					$aDatos[]= array('imageUrl' => $rData['image'], 'name' => $rData['title']." - ".$fecha, 
					'value' => self::$TControl->TPosts->formatUrl($rData['idpost'],$rData['title']));
                }
				break;
			case "relations":
				$aData=self::$TControl->TPosts->get("title like '%".urlencode($search)."%' OR summary like '%".urlencode($search)."%'","0,20");
				foreach ($aData as $rData) 
				{
                    $fecha=substr($rData['published'],0,10);
					$aDatos[]= array('imageUrl' => $rData['image'], 'name' => $rData['title']." - ".$fecha, 
					'value' => self::$TControl->TPosts->formatUrl($rData['idpost'],$rData['title']));
                }

				break;
		}
		
		self::$TControl->TView->openView("responselist");
		self::$TControl->TView->Execute("responselist",$aDatos);

	}
	
	static public function saveImagesDirect()
   {
		$aData['imagen']=self::$TControl->TTable->setFileFromUrl($_POST['urlimagen']);
       echo self::$TControl->TLoggedon->siteurl.$aData['imagen'];
	}
	
	static public function saveImagesFromPostFile()
   {
		$filename=self::$TControl->TTable->setFileFromInput("urlimage");
		if($filename) {
			echo self::$TControl->TLoggedon->siteurl.$filename;
		} else {
			echo 'false';
		}
	}
	
	static public function saveMediaFromPostFile()
   {
		if(self::$TControl->TLoggedon->idsite>0) {
			$sFolder=self::$TControl->TLoggedon->codename."/uploads/posts/";
			$sFolderURL="/uploads/posts/";
		} else {
			$sFolder="all/uploads/";
			$sFolderURL="uploads/";
		}
		$filename=self::$TControl->TUpload->UploadFile("tmpmedia",$sFolder,$sFolderURL);
		if($filename) {
			echo _TB_HOST.$filename;
		} else {
			echo 'false';
		}
	}
	
	static public function setFutbol()
    {
		if(!self::$TControl->TLoggedon->isLogin()) { echo "error de session"; return false; } 
		self::$TControl->TFutbol->setFutbol();
	}

	static public function setCodenames()
	{
		$aData=self::$TControl->TSites->getList();
		foreach($aData as $rData)
		{
			$rData["codename"]=self::$TControl->TSites->createcodename($rData["url"]);
			self::$TControl->TSites->createPaths($rData["idsite"],$rData["codename"]);
			self::$TControl->TSites->set($rData);
		}
		header("Location: "._TB_HOSTADMIN);
	}

}
?>