<?php
require_once ("admin.php");
Class TControllerProfiles extends TControllerAdmin
{
	static private $TControl=NULL;
	static public $aSteps=NULL;
	
	public function __construct(TControl $TControl)
	{
		parent::__construct($TControl);
		self::$TControl = $TControl;
	}

	static public function startController($aParam=false)
	{
		if(self::$TControl->TLoggedon->isLogin())
		{
         self::$aSteps=[];
		   self::$aSteps["settings"]=array("web","identity","social","devcfg");
         self::$aSteps["profiles"]=array("profiles","password","usernew");
			self::$aSteps["design"]=array("template","logo","json","css");
			
         $sParamStep=isset($aParam[0])?$aParam[0]:self::$aSteps[$aParam["action"]][0];
         $sParamGroup=isset($aParam["action"])?$aParam["action"]:$sParamStep;
         $space="profiles/".$sParamGroup."/";
         $rParam=[];
         $rParam["step"]=$sParamStep;
         $rParam["group"]=$sParamGroup;
         self::stepController($rParam,$space);
		} else {
			header("Location: "._TB_HOST."login/" );
		}
	}

   static public function profiles($aParam) { self::startController($aParam);  }
   static public function design($aParam) { self::startController($aParam); }
   static public function settings($aParam) { self::startController($aParam); }


	static public function stepController($aParam,$space="wizard/")
	{
		$step=$aParam["step"];
		$group=isset($aParam["group"])?$aParam["group"]:"data";
		$bigData=self::getBigData($step);
		$view=self::getView($step,"view");
      	$form=self::getView($step,"action");
      
		$message=isset($aParam["message"])?$aParam["message"]:"";

		self::$TControl->TView->openView("adminhead");
		self::$TControl->TView->Execute("adminhead",parent::$bigControl);

		self::$TControl->TView->openView("adminleft");
		self::$TControl->TView->Execute("adminleft",$space); 
		
		self::$TControl->TView->openView("adminnav");
    	self::$TControl->TView->Execute("adminnav"); 
      
		self::$TControl->TView->openView("wizard");
    	self::$TControl->TView->Execute("wizardControl",$step,$group,self::$aSteps,$space);

    	$formTop=self::$TControl->TView->getBlock("managerformtop");
		$formBottom=self::$TControl->TView->getBlock("managerformbottom");
		$formTop = str_replace("[message]", $message, $formTop);
		$formTop = str_replace("[action]", $step, $formTop);
		$formTop = str_replace("[host]", _TB_HOSTADMIN."wizard/", $formTop);
		$formBottom=str_replace("Guardar y Salir","Guardar y Continuar", $formBottom);
		$formBottom=str_replace("Salir sin Guardar","No guardar y Continuar luego", $formBottom);
		if($step=="json") {
			$formTop = str_replace("multipart/form-data", "", $formTop);	
		}

      $formTop .= '<input type="hidden" name="jsongetdata[step]" value="'.$step.'" />';
      if($space=="wizard/")
      {
         $formTop .= '<input type="hidden" name="locationhref" value="'.$space.'" />';
      } else {
         $formTop .= '<input type="hidden" name="locationhref" value="'.$space.$step.'" />';
      }

		self::$TControl->TView->openView($view);
		self::$TControl->TView->Execute($form,$bigData,$formTop,$formBottom);

		self::$TControl->TView->openView("adminfooter");
		switch($step)
		{
			case "logo": $aScriptFooter=array("dropify"); break;
			case "json": $aScriptFooter=array("jsoneditor"); break; 
			case "css": $aScriptFooter=array("csseditor"); break; 
			case "template": $aScriptFooter=array("miperfiltemplate"); break;
			case "web": $aScriptFooter=array("register"); break;
			default: $aScriptFooter=[]; 
		}
		
		self::$TControl->TView->Execute("adminfooter",$aScriptFooter);

	}

	static public function getView($step=false,$type="view") 
	{
		switch($step)
		{
			case 'sections':
         case 'categories':
         case 'trends':
         case 'sources':
         case 'news':
            return (($type=="view")?"settings/":"")."select".$step;
         case 'profiles':
         case 'password':
            return (($type=="view")?"profiles/":"").$step;
         case 'usernew':
            return (($type=="view")?"profiles/":"")."userform";
         default:
            return (($type=="view")?"settings/":"")."settings".$step;
				//return "settings/settings".$step;
		}
	}
	
	static public function getBigData($step=false) 
	{
		switch ($step) {
			case 'template':
				$bigData=self::$TControl->TSites->getDataPack(array(1=>self::$TControl->TLoggedon->idsite));
				require_once _TB_PATHFRAMEWORK."tfonts.php";
				$TFonts = new TFonts(self::$TControl);
				$bigData["googlefonts"]=$TFonts->get();
				return $bigData;
			case 'identity':
			case 'social':
			case 'devcfg':
			case 'json':
			case 'css':
			case 'web':
				return self::$TControl->TSites->getDataPack(array(1=>self::$TControl->TLoggedon->idsite));
			case 'categories':
				return self::$TControl->TCategories->getOrdByID(true);
			case 'sources':
				return self::$TControl->TSources->getBySites();
			case 'trends':
				return self::$TControl->TTrends->getOrdByID(true);
			case 'html':
				return self::$TControl->TSites->getJsonStyle();
			case 'news':
            return self::$TControl->TRepository->getCablera();
         case 'profiles':
            return self::$TControl->TUsers->getList();
			default:
				return false;
		}
	}

	static public function guardar($aParam=false) 
	{
		if(isset($aParam[0])) {
			$function="guardarw_".$aParam[0];
			self::$function();
		}
		return false;
	}

	/** Primero pasos */
	static public function guardarw_web() 
	{
		self::$TControl->TSites->createPaths();
      self::$TControl->TSites->set($_POST);
      $location=isset($_POST["locationhref"])?$_POST["locationhref"]:"wizard/";
		header("Location: "._TB_HOSTADMIN.$location);
	}

	static public function guardarw_usernew() 
	{
      self::$TControl->TUsers->set($_POST);
      $location=isset($_POST["locationhref"])?$_POST["locationhref"]:"profiles/";
		header("Location: "._TB_HOSTADMIN.$location);
	}

	static public function guardarw_identity() 
	{
      self::$TControl->TSites->set($_POST);
      $location=isset($_POST["locationhref"])?$_POST["locationhref"]:"wizard/";
		header("Location: "._TB_HOSTADMIN.$location);
	}

	static public function guardarw_css() 
	{
		file_put_contents(self::$TControl->TSites->getFileCSSStyle(),stripslashes($_POST["css"]));
		self::guardarw_jsongetdata("css");
		$location=isset($_POST["locationhref"])?$_POST["locationhref"]:"wizard/";
		header("Location: "._TB_HOSTADMIN.$location);
	}

	static public function guardarw_json() 
	{
		file_put_contents(self::$TControl->TSites->getFileJsonStyle(),'{"response":{'.substr(stripslashes($_POST["json"]),1,-1)."}}");
		self::guardarw_jsongetdata("json");
		$location=isset($_POST["locationhref"])?$_POST["locationhref"]:"wizard/";
		header("Location: "._TB_HOSTADMIN.$location);
	}
	
	static public function guardarw_news() 
	{
		self::$TControl->TPosts->initialposts($_POST);
      self::guardarw_jsongetdata("news");
      $location=isset($_POST["locationhref"])?$_POST["locationhref"]:"wizard/";
		header("Location: "._TB_HOSTADMIN.$location);
	}


	static public function guardarw_template() 
	{
		/**** ESTO HAY QUE METERLO EN LA PERSONALIZACION DEL JSON
		
		if(!file_exists($pathSite."json/".$family.".json")) { copy($pathBasePack.$family.".json",$pathSite."json/".$family.".json"); }
		
		*/
		
		$replace=($_POST["jsongetdata"]["template"]["columns"]!=$_POST["jsongetdata"]["template"]["prevColumns"]);

		if($replace)
		{
			self::$TControl->TSites->copyJson($_POST["jsongetdata"]["template"]["family"],$_POST["jsongetdata"]["template"]["columns"]);
		}
		
		$sColorFile=self::$TControl->TSites->getCSSStyle("color");
		$sColorFile=str_replace("[bodybackground]","#".$_POST["jsongetdata"]["template"]["bodybackground"],$sColorFile);
		$sColorFile=str_replace("[maincolor]","#".$_POST["jsongetdata"]["template"]["maincolor"],$sColorFile);
		$sColorFile=str_replace("[secondarycolor]","#".$_POST["jsongetdata"]["template"]["secondarycolor"],$sColorFile);
		$sColorFile=str_replace("[hovercolor]","#".$_POST["jsongetdata"]["template"]["hovercolor"],$sColorFile);
		$sColorFile=str_replace("[footercolor]","#".$_POST["jsongetdata"]["template"]["footercolor"],$sColorFile);

		$sColorFile=str_replace($_POST["jsongetdata"]["template"]["prevBodybackground"],$_POST["jsongetdata"]["template"]["bodybackground"],$sColorFile);
		$sColorFile=str_replace($_POST["jsongetdata"]["template"]["prevMaincolor"],$_POST["jsongetdata"]["template"]["maincolor"],$sColorFile);
		$sColorFile=str_replace($_POST["jsongetdata"]["template"]["prevSecondarycolor"],$_POST["jsongetdata"]["template"]["secondarycolor"],$sColorFile);
		$sColorFile=str_replace($_POST["jsongetdata"]["template"]["prevHovercolor"],$_POST["jsongetdata"]["template"]["hovercolor"],$sColorFile);
		$sColorFile=str_replace($_POST["jsongetdata"]["template"]["prevFootercolor"],$_POST["jsongetdata"]["template"]["footercolor"],$sColorFile);
		$sColorFile=str_replace("##","#",$sColorFile);

		file_put_contents(self::$TControl->TSites->getFileCSSStyle("color"),$sColorFile);

		$sFontFile=self::$TControl->TSites->getCSSStyle("font");
		$sFontFile=str_replace("[fontfamily]",$_POST["jsongetdata"]["template"]["fontfamily"],$sFontFile);
		$sFontFile=str_replace($_POST["jsongetdata"]["template"]["prevFontfamily"],$_POST["jsongetdata"]["template"]["fontfamily"],$sFontFile);
		file_put_contents(self::$TControl->TSites->getFileCSSStyle("font"),$sFontFile);

		self::$TControl->TSites->set($_POST);
      $location=isset($_POST["locationhref"])?$_POST["locationhref"]:"wizard/";
		header("Location: "._TB_HOSTADMIN.$location);
	}

	static public function guardarw_social() 
	{
      self::$TControl->TSites->set($_POST);
      $location=isset($_POST["locationhref"])?$_POST["locationhref"]:"wizard/";
		header("Location: "._TB_HOSTADMIN.$location);
	}

	static public function guardarw_devcfg() 
	{
      self::$TControl->TSites->set($_POST);
      $location=isset($_POST["locationhref"])?$_POST["locationhref"]:"wizard/";
		header("Location: "._TB_HOSTADMIN.$location);
	}

	static public function guardarw_sections() 
	{
		$aOptions=array("Titular"=>"public","Normal"=>"open","Tendencias"=>"public");
		foreach ($aOptions as $option=>$mode) 
		{
			if(isset($_POST[$option]["check"])) 
			{
				$aData=[];
				$aData["idsite"]=self::$TControl->TLoggedon->idsite;
				$aData["position"]=$_POST[$option]["ord"];
				$aData["qty"]=$_POST[$option]["qty"];
				$aData["name"]=$option;
				$aData["mode"]=$mode;
				$aData["active"]="on";
				self::$TControl->TSections->set($aData);
			} 
		}
      self::guardarw_jsongetdata("sections");
      $location=isset($_POST["locationhref"])?$_POST["locationhref"]:"wizard/";
		header("Location: "._TB_HOSTADMIN.$location);	
	}

	static public function guardarw_categories() 
	{
		$aData=self::getBigData("categories");
		$i=0;
		foreach ($aData as $id=>$rData) 
		{
			if(isset($_POST["cat".$id]["id"])) 
			{
				$oData=[];
				$oData["idsite"]=self::$TControl->TLoggedon->idsite;
				$oData["idparent"]=$id;
				$oData["position"]=$i++;
				$oData["title"]=$_POST["cat".$id]["title"];
				$oData["qty"]=12;
				$oData["active"]="on";
				self::$TControl->TCategories->set($oData);
			} 
		}
      self::guardarw_jsongetdata("categories");
      $location=isset($_POST["locationhref"])?$_POST["locationhref"]:"wizard/";
		header("Location: "._TB_HOSTADMIN.$location);	
	}

	static public function guardarw_sources() 
	{
		$aData=self::getBigData("sources");
		$i=0;
		print_r($_POST);
		foreach ($aData as $k=>$rData) 
		{
			$id=$rData["idsource"];
			if(isset($_POST["source".$id]))
			{
				$oData=[];
				$oData["idsource"]=$rData["idsource"];
            $oData["checked"]="true";
				$oData["idsite"]=self::$TControl->TLoggedon->idsite;
				$oData["keywords"]=$_POST["key".$id];
				self::$TControl->TSources->setSourcesBySites($oData);
			} 
		}
      self::guardarw_jsongetdata("sources");
      $location=isset($_POST["locationhref"])?$_POST["locationhref"]:"wizard/";
		header("Location: "._TB_HOSTADMIN.$location);	
	}

	static public function guardarw_trends() 
	{
		$aData=self::getBigData("trends");
		$i=0;
		foreach ($aData as $id=>$rData) 
		{
			if(isset($_POST["trend".$id]["id"])) 
			{
				$oData=[];
				$oData["idsite"]=self::$TControl->TLoggedon->idsite;
				$oData["idparent"]=$id;
				$oData["position"]=$i++;
				$oData["title"]=$_POST["trend".$id]["title"];
				$oData["active"]="on";
				$oData["visible"]="on";
				self::$TControl->TTrends->set($oData);
			} 
		}
      self::guardarw_jsongetdata("trends");
      $location=isset($_POST["locationhref"])?$_POST["locationhref"]:"wizard/";
		header("Location: "._TB_HOSTADMIN.$location);	
	}
	

	static public function guardarw_logo() 
	{
		if(isset($_FILES["logoimage"]["name"]) && $_FILES["logoimage"]["name"]!="") 
		{
			$aVerotAttrib = array("image_x"=>240,"image_y"=>90, "image_resize"=>false, "image_ratio_crop"=>true, "image_convert" => "png" );
			$sFileImage=self::$TControl->TUpload->UploadImageFromInput("logoimage",self::$TControl->TLoggedon->codename."/template/img/",self::$TControl->TLoggedon->siteurl.self::$TControl->TLoggedon->codename."/template/img/",$aVerotAttrib,"logo");
		}

		if(isset($_FILES["genericimage"]["name"]) && $_FILES["genericimage"]["name"]!="") 
		{
			$aVerotAttrib = array("image_x"=>1200,"image_y"=>628, "image_resize"=>true, "image_ratio_crop"=>true, "image_convert" => "png" );
			$sFileImage=self::$TControl->TUpload->UploadImageFromInput("logoimage",self::$TControl->TLoggedon->codename."/template/img/",self::$TControl->TLoggedon->siteurl.self::$TControl->TLoggedon->codename."/template/img/",$aVerotAttrib,"generica");
		}
		
		if(isset($_FILES["iconimage"]["name"]) && $_FILES["iconimage"]["name"]!="") 
		{
			$aFormats=array(16,32,128,144,152,192,512,1024);
			foreach($aFormats as $i)
			{
				$aVerotAttrib = array("image_x"=>$i,"image_y"=>$i, "image_resize"=>true, "image_ratio_crop"=>true, "image_convert" => "png" );
				$sFileImage=self::$TControl->TUpload->UploadImageFromInput("iconimage",self::$TControl->TLoggedon->codename."/template/img/",self::$TControl->TLoggedon->siteurl.self::$TControl->TLoggedon->codename."/template/img/",$aVerotAttrib,"an-icon-".$i);
			}
		}
      self::guardarw_jsongetdata("logo");
      $location=isset($_POST["locationhref"])?$_POST["locationhref"]:"wizard/";
		header("Location: "._TB_HOSTADMIN.$location);	
	}

	static public function guardarw_jsongetdata($step)
	{
		$aData=[];
		$aData["idsite"]=self::$TControl->TLoggedon->idsite;
		$aData["jsongetdata"]=[];
		$aData["jsongetdata"]["step"]=$step;
		self::$TControl->TSites->set($aData);
		return true;
		//header("Location: "._TB_HOSTADMIN.$location);
	}

}
?>