(function($) {
    $.fn.ceibooEditor = function(opts) {
        if (opts && typeof (opts) === "string") {
            var args = [];
            for (var i = 1; i < arguments.length; i++) { args.push(arguments[i]); }
            var htmlarea = JCeibooEditor(this[0]);
            var f = htmlarea[opts];
            if (f) { return f.apply(htmlarea, args); }
        }
        return this.each(function() { JCeibooEditor(this, opts); });
    };
    var JCeibooEditor = window.JCeibooEditor = function(element, options) {
    	
        if (element.jquery) {
            return JCeibooEditor(element[0]);
        }
        if (element.JCeibooEditorObject) {
            return element.JCeibooEditorObject;
        } else {
            return new JCeibooEditor.fn.init(element, options);
        }
    };
    
    JCeibooEditor.fn = JCeibooEditor.prototype = {

        // Version Actual
        JCeibooEditor: "0.1.0",

        init: function(element, options) {
            console.log("element.id", element.id);
            if (element.nodeName.toLowerCase() === "textarea") {
            	element.JCeibooEditorObject = this;
                
                opts = $.extend({}, JCeibooEditor.defaultOptions, options);
                opts.elementId=privateFunctions.initRndEmelentId("99999");
                
                content=this.changeAttributeQuotes($(element).html());
                $(element).html(content);

                var tagTextarea = this.tagTextarea = $(element);
                console.log("tagTextarea", $(element).html());

                //Construccion de la ventana del editor
                this.container = $("<div/>", { 
                		class:"ceibooEditor"
                }).insertAfter(tagTextarea);
                /*this.container.css("float","left");*/
                
                
                var container = this.container; 
                
                //Construccion de la barra de herramientas
                this.toolbar = $("<div/>", {
                    class:"ceibooEditor-toolbar"
                }).appendTo(container);
                var toolbar = this.toolbar;
                
                //Construccion del area de contenidos
                this.tagIframe = $("<iframe/>",{
                    id:opts.elementId
                });
                //this.tagIframe.append('<style type="text/css">  * { font-family: "Roboto", "Helvetica", "Arial", sans - serif;} </style>');
                /*this.tagIframe = $("<div content-editable='true' />", {
                    id: opts.elementId
                });*/
                var tagIframe = this.tagIframe;
                
                /*tagIframe.height(tagTextarea.height());*/
                /*tagIframe.width(tagTextarea.width());*/
                this.htmlarea = $("<div/>",{class:"ceibooEditor-editor"}).append(tagIframe);
                var htmlarea = this.htmlarea;

                container.append(htmlarea).append(tagTextarea.hide());

                //Construccion de la caja de dialogo
                this.dialog = $("<div/>", {
                    class: "ceibooEditor-dialog",
                    height: tagTextarea.height()
                });
                var dialog = this.dialog;
                container.append(dialog.hide());

                
                //Funciones Privadas
                privateFunctions.initToolBar.call(this, opts);
                privateFunctions.initEditor.call(this, opts, this.container);
                privateFunctions.attachEditorEvents.call(this);
                
                // Repara la altura total para que coincida con el textarea
                //tagIframe.height(tagIframe.height() - toolbar.height());

                //toolbar.width(tagTextarea.width() - 2);

            	
                if (opts.loaded) { opts.loaded.call(this); }
                
                
            }
        },
        changeAttributeQuotes: function(string) {
        if (!string) {
            return '';
        }

        var regex;
        var rstring;
        if (opts.useSingleQuotes === true) {
            regex = /\s+(\w+\s*=\s*(["][^"]*["])|(['][^']*[']))+/g;
            rstring = string.replace(regex, function ($0, $1, $2) {
                if (!$2) { return $0; }
                return $0.replace($2, $2.replace(/\"/g, "'"));
            });
        } else {
            regex = /\s+(\w+\s*=\s*(['][^']*['])|(["][^"]*["]))+/g;
            rstring = string.replace(regex, function ($0, $1, $2) {
                if (!$2) { return $0; }
                return $0.replace($2, $2.replace(/'/g, '"'));
            });
        }
        return rstring;
    },
        execCommand: function(a, b, c) {
            this.tagIframe[0].contentWindow.focus();
            this.editor.execCommand(a, b || false, c || null);
            //this.updatetagTextarea();
        },
        ec: function(a, b, c) {
            this.execCommand(a, b, c);
        },
        queryCommandValue: function(a) {
            this.tagIframe[0].contentWindow.focus();
            return this.editor.queryCommandValue(a);
        },
        qc: function(a) {
            return this.queryCommandValue(a);
        },
        getSelectedHTML: function() {
            if ($.browser.msie) {
                return this.getRange().htmlText;
            } else {
                var elem = this.getRange().cloneContents();
                return $("<p/>").append($(elem)).html();
            }
        },
        getSelection: function() {
            if ($.browser.msie) {
                return this.editor.selection;
            } else {
                return this.tagIframe[0].contentDocument.defaultView.getSelection();
            }
        },
        getRange: function() {
            var s = this.getSelection();
            if (!s) { return null; }
            return (s.getRangeAt) ? s.getRangeAt(0) : s.createRange();
        },
        html: function(v) {
            if (v) {
                this.pastHTML(v);
            } else {
                return toHtmlString();
            }
        },
        pasteHTML: function(html) {
            this.tagIframe[0].contentWindow.focus();
            var r = this.getRange();
            if ($.browser.msie) {
                r.pasteHTML(html);
            } else if ($.browser.mozilla) {
                r.deleteContents();
                r.insertNode($((html.indexOf("<") != 0) ? $("<span/>").append(html) : html)[0]);
            } else { // Safari
                r.deleteContents();
                r.insertNode($(this.tagIframe[0].contentWindow.document.createElement("span")).append($((html.indexOf("<") != 0) ? "<span>" + html + "</span>" : html))[0]);
            }
            r.collapse(false);
            r.select();
        },
        cut: function() {
            this.ec("cut");
        },
        copy: function() {
            this.ec("copy");
        },
        paste: function() {
            this.ec("paste");
        },
        bold: function() { this.ec("bold"); },
        italic: function() { this.ec("italic"); },
        underline: function() { this.ec("underline"); },
        strikeThrough: function() { this.ec("strikethrough"); },
        /*image: function(url) {
        	if(opts.image) {
        		opts.image(this.tagIframe.attr("id"));
        	} else {
	    		if ($.browser.msie && !url) {
	                this.ec("insertImage", true);
	            } else {
	                this.ec("insertImage", false, (url || prompt("Image URL:", "http://")));
	            }
        	}
        },*/
        removeFormat: function() {
            this.ec("removeFormat", false, []);
            this.unlink();
        },
        link: function() {
            if ($.browser.msie) {
                this.ec("createLink", true);
            } else {
                this.ec("createLink", false, prompt("Link URL:", "http://"));
            }
        },
        unlink: function() { this.ec("unlink", false, []); },
        orderedList: function() { this.ec("insertorderedlist"); },
        unorderedList: function() { this.ec("insertunorderedlist"); },
        superscript: function() { this.ec("superscript"); },
        subscript: function() { this.ec("subscript"); },

        p: function() {
            this.formatBlock("<p>");
        },
        h1: function() {
            this.heading(1);
        },
        h2: function() {
            this.heading(2);
        },
        h3: function() {
            this.heading(3);
        },
        h4: function() {
            this.heading(4);
        },
        h5: function() {
            this.heading(5);
        },
        h6: function() {
            this.heading(6);
        },
        fontfamily: function(btn) {
        	//this.execCommand("fontname", false, "Arial");
        },
        changetofullscreen: function() {
        	if(this.container.width()<$(document).width() && this.container.height()<$(document).height()) {
        		this.tagTextarea.addClass("tagTextareafullscreen");
        		this.container.addClass("fullscreen");
			} else {
        		this.tagTextarea.removeClass("tagTextareafullscreen");
				this.container.removeClass("fullscreen");
			}
        },
        heading: function(h) {
            this.formatBlock("<h"+h+">");
        },
        blockquote: function () {
            this.formatBlock("blockquote");
        },
        indent: function() {
            this.ec("indent");
        },
        outdent: function() {
            this.ec("outdent");
        },

        insertHorizontalRule: function() {
            this.ec("insertHorizontalRule", false, "ht");
        },

        justifyLeft: function() {
            this.ec("justifyLeft");
        },
        justifyCenter: function() {
            this.ec("justifyCenter");
        },
        justifyRight: function() {
            this.ec("justifyRight");
        },

        increaseFontSize: function() {
            if ($.browser.msie) {
                this.ec("fontSize", false, this.qc("fontSize") + 1);
            } else if ($.browser.safari) {
                this.getRange().surroundContents($(this.tagIframe[0].contentWindow.document.createElement("span")).css("font-size", "larger")[0]);
            } else {
                this.ec("increaseFontSize", false, "big");
            }
        },
        decreaseFontSize: function() {
            if ($.browser.msie) {
                this.ec("fontSize", false, this.qc("fontSize") - 1);
            } else if ($.browser.safari) {
                this.getRange().surroundContents($(this.tagIframe[0].contentWindow.document.createElement("span")).css("font-size", "smaller")[0]);
            } else {
                this.ec("decreaseFontSize", false, "small");
            }
        },

        forecolor: function(c) {
        	if(opts.forecolor) {
        		opts.forecolor();
        	} else {
        		this.ec("foreColor", false, c || prompt("Enter HTML Color:", "#"));
        	}
        },

        formatBlock: function(v) {
            this.ec("formatblock", false, v || null);
        },

        showHTMLView: function() {
            this.updatetagTextarea();
            this.tagTextarea.show();
            this.htmlarea.hide();
            this.editor.body.style.display = "none"; 
        },
        hideHTMLView: function() {
            this.updateHtmlArea();
            this.tagTextarea.hide();
            this.htmlarea.show();
            this.editor.body.style.display = "block"; 
        },
        toggleHTMLView: function() {
            (this.tagTextarea.is(":hidden")) ? this.showHTMLView() : this.hideHTMLView();
        },

        toHtmlString: function() {
            return this.editor.body.innerHTML;
        },
        toString: function() {
            return this.editor.body.innerText;
        },

        updatetagTextarea: function() {
            this.tagTextarea.val(this.toHtmlString());
        },
        updateHtmlArea: function() {
            this.editor.body.innerHTML = this.tagTextarea.val();
        },
        pasteHTMLAtCaret: function(html) {
            // add HTML code for Internet Explorer
            var sel, range;
            if (window.getSelection) {
                // IE9 and non-IE
                sel = window.getSelection();
                if (sel.getRangeAt && sel.rangeCount) {
                    range = sel.getRangeAt(0);
                    range.deleteContents();

                    // Range.createContextualFragment() would be useful here but is
                    // only relatively recently standardized and is not supported in
                    // some browsers (IE9, for one)
                    var el = document.createElement("div");
                    el.innerHTML = html;
                    var frag = document.createDocumentFragment(), node, lastNode;
                    while ((node = el.firstChild)) {
                        lastNode = frag.appendChild(node);
                    }
                    range.insertNode(frag);

                    // Preserve the selection
                    if (lastNode) {
                        range = range.cloneRange();
                        range.setStartAfter(lastNode);
                        range.collapse(true);
                        sel.removeAllRanges();
                        sel.addRange(range);
                    }
                }
            } else if (document.selection && document.selection.type !== "Control") {
                // IE < 9
                document.selection.createRange().pasteHTML(html);
            }
        },
        restoreSelection: function(editorID, media, url) 
        {
            var containerEl = document.getElementById(editorID);
            var savedSel = savedSelection;
            if (!savedSel) {
                // fix selection if editor has not been focused
                savedSel = {
                    'start': 0,
                    'end': 0,
                    'type': 'caret',
                    'editorID': editorID,
                    'anchor': $('#' + editorID).children('div')[0]
                };
            }

            if (savedSel.editorID !== editorID) {
                return false;
            } else if (media === true) {
                containerEl = (savedSel.anchor ? savedSel.anchor : containerEl); // fix selection issue
            } else if (url === true) {
                if (savedSel.start === 0 && savedSel.end === 0) {
                    containerEl = (savedSel.anchor ? savedSel.anchor : containerEl); // fix selection issue
                }
            }

            if (window.getSelection && document.createRange) {
                var charIndex = 0, range = document.createRange();
                if (!range || !containerEl) { window.getSelection().removeAllRanges(); return true; }
                range.setStart(containerEl, 0);
                range.collapse(true);
                var nodeStack = [containerEl], node, foundStart = false, stop = false;

                while (!stop && (node = nodeStack.pop())) {
                    if (node.nodeType === 3) {
                        var nextCharIndex = charIndex + node.length;
                        if (!foundStart && savedSel.start >= charIndex && savedSel.start <= nextCharIndex) {
                            range.setStart(node, savedSel.start - charIndex);
                            foundStart = true;
                        }
                        if (foundStart && savedSel.end >= charIndex && savedSel.end <= nextCharIndex) {
                            range.setEnd(node, savedSel.end - charIndex);
                            stop = true;
                        }
                        charIndex = nextCharIndex;
                    } else {
                        var i = node.childNodes.length;
                        while (i--) {
                            nodeStack.push(node.childNodes[i]);
                        }
                    }
                }
                var sel = window.getSelection();
                sel.removeAllRanges();
                sel.addRange(range);
            }
        },

        image: function (url) {
            var thisClass = this;
            var sWidth = "600px";
                swal({
                    title: 'Insertá el texto a buscar',
                    html:
                        '<input id="swal-input1" style="width:80%; margin:0px 2%" >' +
                        '<input id="swal-input2" value="' + sWidth +'" style="width:14%; margin:0px 2% 0px 0px">',
                    focusConfirm: false,
                    showCancelButton: true,
                    preConfirm: function () {
                        texto=$('#swal-input1').val();
                        sWidth=$('#swal-input2').val();
                        if(texto=="")
                        {
                            return false;
                        }
                        return $.post(hostadmin + "ajaxFiles/googleimages/" + texto + "/").done(function (data) {
                            $('.ceibooEditor-dialog').html(data);
                            return true;
                        })
                    },
                    allowOutsideClick: () => !swal.isLoading()
                }).then((result) => {
                    if (result) {

                        $('.ceibooEditor-dialog').show();
                        $('.ceibooEditor-editor').hide();
                        // disable non working buttons
                        $('.ceibooEditor-toolbar').find('.ceibooEditor-btn').each(function () {
                            if ($(this).attr("data-command") != 'insertImageGoogle') {
                                $(this).parent('li').attr("data-disable", "true");
                            }
                        });
                        $('.ceibooEditor-dialog').find('.card').each(function () {
                            var self = this;
                            $(this).click(function () {
                                var dataItem = $(self).attr("data-img");
                                var dataCaption = $(self).attr("data-title");
                                var html = '';
                                $.post(hostadmin + "saveImagesDirect/", { urlimagen: dataItem }).
                                    done(function (data) {
                                        html = '<figure class="image"><img src="' + data + '" alt="' + dataCaption + '" class="entry-thumbnail" width="' + sWidth+'"><figcaption>' + dataCaption + '</figcaption></figure>';
                                        //restoreSelection(editorID, true);
                                        console.log(html);
                                        thisClass.ec('insertHTML', true, html);
                                        //thisClass.pasteHTMLAtCaret(html);
                                        $('.ceibooEditor-dialog').hide();
                                        $('.ceibooEditor-editor').show();
                                    }).fail(function () {
                                        $('.ceibooEditor-dialog').hide();
                                        $('.ceibooEditor-editor').show();

                                    });

                            });
                        });
                    }
                });
        }

    };
    JCeibooEditor.fn.init.prototype = JCeibooEditor.fn;

    JCeibooEditor.defaultOptions = {
        toolbar: [
        ["blockquote","bold", "italic", "underline", "strikethrough", "subscript", "superscript"],
        ["cut", "copy", "paste"],
        /*["increasefontsize", "decreasefontsize"],*/
        ["orderedlist", "unorderedlist"],
        ["indent", "outdent"],
        ["justifyleft", "justifycenter", "justifyright"],
        ["link", "image", "horizontalrule"],
        ["h1", "h2", "h3", "h4", "h5", "h6"],
        //["fontfamily"],
        ["html"],["changetofullscreen"]
    ],
        useSingleQuotes: true,
        css: null,
        toolbarText: {
            blockquote: "Parrafo resaltado",
            bold: "Negrita", italic: "Itálica", underline: "Subrayada", strikethrough: "Strike-Through",
            cut: "Cortar", copy: "Copiar", paste: "Pegar",
            h1: "Título 1", h2: "Título 2", h3: "Título 3", h4: "Título 4", h5: "Título 5", h6: "Título 6", p: "Párrafo",
            indent: "Margen", outdent: "Outdent", horizontalrule: "Linea Horizontal",
            justifyleft: "Alinear izquierda", justifycenter: "Centrar", justifyright: "Alinear derecha",
            increasefontsize: "Increase Font Size", decreasefontsize: "Decrease Font Size", forecolor: "Text Color",
            link: "Enlace relacionado", unlink: "Remove Link", image: "Insertar Imagen",
            orderedlist: "lista ordenada", unorderedlist: "lista",
            subscript: "Subscript", superscript: "Superscript",
            changetofullscreen: "Cambiar a pantalla completa",
            //fontfamily:"Font Family",
            html: "Ver código HTML"
        },
        toolbarIcon: {
            blockquote: "quote-left", bold: "bold", italic: "italic", underline: "underline", strikethrough: "strikethrough",
            cut: "cut", copy: "copy", paste: "paste",
            h1: "dice-one", h2: "dice-two", h3: "dice-three", h4: "dice-four", h5: "dice-five", h6: "dice-six", p: "title",
            indent: "indent", outdent: "outdent", horizontalrule: "window-minimize",
            justifyleft: "align-left", justifycenter: "align-center", justifyright: "align-right",
            increasefontsize: "size", decreasefontsize: "text_fields", forecolor: "color_text",
            link: "link", unlink: "link-off", image: "image",
            orderedlist: "list-ol", unorderedlist: "list-ul",
            subscript: "subscript", superscript: "superscript",
            changetofullscreen: "fullscreen",
            //fontfamily:"Font Family",
            html: "code"
        }
    };
    var privateFunctions = {
        toolbarButtons: {
            strikethrough: "strikeThrough", orderedlist: "orderedList", unorderedlist: "unorderedList",
            horizontalrule: "insertHorizontalRule",
            justifyleft: "justifyLeft", justifycenter: "justifyCenter", justifyright: "justifyRight",
            increasefontsize: "increaseFontSize", decreasefontsize: "decreaseFontSize",
            html: function(btn) {
                this.toggleHTMLView();
            }
        },
        initEditor: function(options, container) {
            var edit = this.editor = this.tagIframe[0].contentWindow.document;
            var textedit = edit.getElementsByTagName('body');
            var focused = false;
            edit.designMode = 'on';
            edit.open();
            //edit.write("<textarea style='width:100%; height:100%;'>"+this.tagTextarea.val()+"</textarea>");
            document.execCommand("DefaultParagraphSeparator", true, 'p');
            
            if (this.tagTextarea.val() === "") {
                edit.write('<p><br></p>');
            } else {
                edit.write(this.tagTextarea.val());
            }
            edit.close();

            if (options.css) {
            	for(i=0;i<options.css.length;i++) {
        			var e = edit.createElement('link'); e.rel = 'stylesheet'; e.type = 'text/css'; e.href = options.css[i]; edit.getElementsByTagName('head')[0].appendChild(e);
        		}
            }
            //$(edit.getElementsByTagName('body')[0]).html("<p></p>");
            if (options.selector) {
            	for(i=0;i<options.selector.length;i++) {
        			$(textedit).addClass(options.selector[i]);
            	}
            }
            
            $(textedit).keyup(function(event) { 
               // console.log("keyup", event);
            	privateFunctions.controlKeys(event);
            	/*********************************************************************/
            	/*********************************************************************/
            		/* aca */
            	/*********************************************************************/
            	/*********************************************************************/
            	if(event.keyCode===9 && !focused) { //alert($(container).next().next().next().html()); 
            		
            	}
            	
            	if(focused) { focused=false; }
            });
            
            $(container).focusin(function(event) { 
            	$(textedit).focus();
            	focused=true;
            	event.stopPropagation();
            	});
            $(textedit).focusin(function(event) {
                $(container).css("border","1px solid #d93732");
            });
            $(textedit).focusout(function(event) { 
                $(container).css("border","1px solid #d5d5d5");
           	});

        },
        initToolBar: function(options) {
            var that = this;

            var menuItem = function(className, altText, action) {
                return $("<li/>").append($("<a/>").attr("title", altText).append($("<i class='fas fa-" + className + "'/>")).click(function () { action.call(that, $(this)); }));
                
            };

            function addButtons(arr) {
                
                for (var i = 0; i < arr.length; i++) {
                    var e = arr[i];
                    if ((typeof (e)).toLowerCase() === "string") {
                        if (e === "|") {
                            ul.append($('<li class="separator"/>'));
                        } else {
                            var f = (function(e) {
                                var m = privateFunctions.toolbarButtons[e] || e;
                                if ((typeof (m)).toLowerCase() === "function") {
                                    return function(btn) { m.call(this, btn); };
                                } else {
                                    return function() { this[m](); this.editor.body.focus(); };
                                }
                            })(e.toLowerCase());
                            var t = options.toolbarText[e.toLowerCase()];
                            var icon = options.toolbarIcon[e.toLowerCase()];
                            ul.append(menuItem(icon || e.toLowerCase(), t || e, f));
                        }
                    } else {
                        ul.append(menuItem(e.css, e.text, e.action));
                    }
                }
            };
            var ul = $("<ul/>").appendTo(that.toolbar);
            if (options.toolbar.length !== 0 && privateFunctions.isArray(options.toolbar[0])) {
                for (var i = 0; i < options.toolbar.length; i++) {
                    addButtons(options.toolbar[i]);
                    ul.append("<li class='separator'/>");
                }
            } else {
                addButtons(options.toolbar);
            }
        },
        controlKeys: function(event) {
        	//if(event.keyCode=="9") {
            //alert(this.editor.attr("id"));//}
            console.log("controlKeys", event);
        },
        attachEditorEvents: function() {
            var t = this;

            var fnHA = function() {
                t.updateHtmlArea();
            };

            
            this.tagTextarea.click(fnHA).
            keyup(fnHA).
            keydown(fnHA).
            mousedown(fnHA).
            blur(fnHA);
            
            var fnTA = function() {
                t.updatetagTextarea();
            };

/*            this.editor.click(fnTA).
                keyup(fnTA).
                keydown(fnTA).
                mousedown(fnTA).
                blur(fnTA);
*/
            $(this.editor.body).click(fnTA).
                keyup(fnTA).
                keydown(fnTA).
                mousedown(fnTA).
                blur(fnTA);

            /* $(this.editor.body).focusin(function(event) {
            	alert("aca");
            }*/
            $('form').submit(function() { t.toggleHTMLView(); t.toggleHTMLView(); });


        },
        isArray: function(v) {
            return v && typeof v === 'object' && typeof v.length === 'number' && typeof v.splice === 'function' && !(v.propertyIsEnumerable('length'));
        },
        strip_tags: function (html) {
    		if(arguments.length < 3) {
    			html=html.replace(/<\/?(?!\!)[^>]*>/gi, '');
    		} else {
    			var allowed = arguments[1];
    			var specified = eval("["+arguments[2]+"]");
    			if(allowed){
    				var regex='</?(?!(' + specified.join('|') + '))\b[^>]*>';
    				html=html.replace(new RegExp(regex, 'gi'), '');
    			} else{
    				var regex='</?(' + specified.join('|') + ')\b[^>]*>';
    				html=html.replace(new RegExp(regex, 'gi'), '');
    			}
    		}
     
    		var clean_string = html;
     
    		return clean_string;
    	},
    	initRndEmelentId: function(toNumber) {
    		toNumber=(toNumber ? toNumber : "100");
    		return Math.floor(Math.random()*toNumber);
    	}
    };
})(jQuery);