(function($) {
    $.fn.ceibooEditor = function(opts) {
        if (opts && typeof (opts) === "string") {
            var args = [];
            for (var i = 1; i < arguments.length; i++) { args.push(arguments[i]); }
            var htmlarea = JCeibooEditor(this[0]);
            var f = htmlarea[opts];
            if (f) { return f.apply(htmlarea, args); }
        }
        return this.each(function() { JCeibooEditor(this, opts); });
    };
    var JCeibooEditor = window.JCeibooEditor = function(element, options) {
    	
        if (element.jquery) {
            return JCeibooEditor(element[0]);
        }
        if (element.JCeibooEditorObject) {
            return element.JCeibooEditorObject;
        } else {
            return new JCeibooEditor.fn.init(element, options);
        }
    };
    
    JCeibooEditor.fn = JCeibooEditor.prototype = {

        // Version Actual
        JCeibooEditor: "0.1.0",

        init: function(element, options) {
            console.log("element.id", element.id);
            if (element.nodeName.toLowerCase() === "textarea") {
            	element.JCeibooEditorObject = this;
                
                opts = $.extend({}, JCeibooEditor.defaultOptions, options);
                opts.elementId=privateFunctions.initRndEmelentId("99999");
                
                content=this.changeAttributeQuotes($(element).html());
                $(element).html(content);

                var tagTextarea = this.tagTextarea = $(element);

                // Cargamos las opciones como data-option 
                // Es la forma de recibir parametros y que se actualicen desde fuera del editor
                $.each(options, function (key, value) {
                    $(tagTextarea).attr("data-"+key,value);
                });
                //Construccion de la ventana del editor
                this.container = $("<div/>", { 
                		class:"ceibooEditor"
                }).insertAfter(tagTextarea);
                /*this.container.css("float","left");*/
                
                
                var container = this.container; 
                //Construccion de la barra de herramientas
                this.toolbar = $("<div/>", {
                    class:"ceibooEditor-toolbar"
                }).appendTo(container);
                var toolbar = this.toolbar;
                
                //Construccion del area de contenidos
                this.tagIframe = $("<iframe/>",{
                    id:opts.elementId
                });

                var tagIframe = this.tagIframe;
                
                
                this.htmlarea = $("<div/>",{class:"ceibooEditor-editor"}).append(tagIframe);
                var htmlarea = this.htmlarea;

                container.append(htmlarea).append(tagTextarea.hide());

                //Construccion de la caja de dialogo
                this.dialog = $("<div/>", {
                    class: "ceibooEditor-dialog"
                });
                var dialog = this.dialog;
                container.append(dialog.hide());

                this.wait = $("<div/>", {
                    class: "ceibooEditor-wait"
                });
                var wait = this.wait;
                container.append(wait.hide().append("<div class='wait'><img src='" + hostadmin +"platform/material/img/loading.gif'></div>"));

                /*this.toolbarbottom = $("<div/>", {
                    class: "ceibooEditor-toolbarbottom"
                }).appendTo(container);
                var toolbarbottom = this.toolbarbottom;
                */

                //Funciones Privadas
                privateFunctions.initToolBar.call(this, opts, true);
                privateFunctions.initToolBar.call(this, opts, false);
                privateFunctions.initEditor.call(this, opts, this.container);
                privateFunctions.attachEditorEvents.call(this);
                
                // Repara la altura total para que coincida con el textarea
                //tagIframe.height(tagIframe.height() - toolbar.height());

                //toolbar.width(tagTextarea.width() - 2);

            	
                if (opts.loaded) { opts.loaded.call(this); }
                
                
            }
        },
        changeAttributeQuotes: function(string) {
        if (!string) {
            return '';
        }

        var regex;
        var rstring;
        if (opts.useSingleQuotes === true) {
            regex = /\s+(\w+\s*=\s*(["][^"]*["])|(['][^']*[']))+/g;
            rstring = string.replace(regex, function ($0, $1, $2) {
                if (!$2) { return $0; }
                return $0.replace($2, $2.replace(/\"/g, "'"));
            });
        } else {
            regex = /\s+(\w+\s*=\s*(['][^']*['])|(["][^"]*["]))+/g;
            rstring = string.replace(regex, function ($0, $1, $2) {
                if (!$2) { return $0; }
                return $0.replace($2, $2.replace(/'/g, '"'));
            });
        }
        return rstring;
    },
        execCommand: function(a, b, c) {
            this.tagIframe[0].contentWindow.focus();
            this.editor.execCommand(a, b || false, c || null);
            this.updatetagTextarea();
        },
        ec: function(a, b, c) {
            this.execCommand(a, b, c);
        },
        queryCommandValue: function(a) {
            this.tagIframe[0].contentWindow.focus();
            return this.editor.queryCommandValue(a);
        },
        qc: function(a) {
            return this.queryCommandValue(a);
        },
        getSelectedHTML: function() {
            if ($.browser.msie) {
                return this.getRange().htmlText;
            } else {
                var elem = this.getRange().cloneContents();
                return $("<p/>").append($(elem)).html();
            }
        },
        getSelection: function() {
            if ($.browser.msie) {
                return this.editor.selection;
            } else {
                return this.tagIframe[0].contentDocument.defaultView.getSelection();
            }
        },
        getRange: function() {
            var s = this.getSelection();
            if (!s) { return null; }
            return (s.getRangeAt) ? s.getRangeAt(0) : s.createRange();
        },
        html: function(v) {
            if (v) {
                this.pastHTML(v);
            } else {
                return toHtmlString();
            }
        },
        pasteHTML: function(html) {
            this.tagIframe[0].contentWindow.focus();
            var r = this.getRange();
            if ($.browser.msie) {
                r.pasteHTML(html);
            } else if ($.browser.mozilla) {
                r.deleteContents();
                r.insertNode($((html.indexOf("<") != 0) ? $("<span/>").append(html) : html)[0]);
            } else { // Safari
                r.deleteContents();
                r.insertNode($(this.tagIframe[0].contentWindow.document.createElement("span")).append($((html.indexOf("<") != 0) ? "<span>" + html + "</span>" : html))[0]);
            }
            r.collapse(false);
            r.select();
        },
        cut: function() {
            this.ec("cut");
        },
        copy: function() {
            this.ec("copy");
        },
        paste: function() {
            this.ec("paste");
        },
        bold: function() { this.ec("bold"); },
        italic: function() { this.ec("italic"); },
        underline: function() { this.ec("underline"); },
        strikeThrough: function() { this.ec("strikethrough"); },

        removeFormat: function() {
            this.ec("removeFormat", false, []);
            this.unlink();
        },
        link: function() {
            if ($.browser.msie) {
                this.ec("createLink", true);
            } else {
                this.ec("createLink", false, prompt("Link URL:", "http://"));
            }
        },
        unlink: function() { this.ec("unlink", false, []); },
        orderedList: function() { this.ec("insertorderedlist"); },
        unorderedList: function() { this.ec("insertunorderedlist"); },
        superscript: function() { this.ec("superscript"); },
        subscript: function() { this.ec("subscript"); },

        p: function() {
            this.formatBlock("<p>");
        },
        h1: function() {
            this.heading(1);
        },
        h2: function() {
            this.heading(2);
        },
        h3: function() {
            this.heading(3);
        },
        h4: function() {
            this.heading(4);
        },
        h5: function() {
            this.heading(5);
        },
        h6: function() {
            this.heading(6);
        },
        fontfamily: function(btn) {
        	//this.execCommand("fontname", false, "Arial");
        },
        changetofullscreen: function() {
        	if(this.container.width()<$(document).width() && this.container.height()<$(document).height()) {
        		this.tagTextarea.addClass("tagTextareafullscreen");
        		this.container.addClass("fullscreen");
			} else {
        		this.tagTextarea.removeClass("tagTextareafullscreen");
				this.container.removeClass("fullscreen");
			}
        },
        heading: function(h) {
            this.formatBlock("<h"+h+">");
        },
        blockquote: function () {
            this.formatBlock("blockquote");
        },
        indent: function() {
            this.ec("indent");
        },
        outdent: function() {
            this.ec("outdent");
        },

        insertHorizontalRule: function() {
            this.ec("insertHorizontalRule", false, "ht");
        },

        justifyLeft: function() {
            this.ec("justifyLeft");
        },
        justifyCenter: function() {
            this.ec("justifyCenter");
        },
        justifyRight: function() {
            this.ec("justifyRight");
        },

        increaseFontSize: function() {
            if ($.browser.msie) {
                this.ec("fontSize", false, this.qc("fontSize") + 1);
            } else if ($.browser.safari) {
                this.getRange().surroundContents($(this.tagIframe[0].contentWindow.document.createElement("span")).css("font-size", "larger")[0]);
            } else {
                this.ec("increaseFontSize", false, "big");
            }
        },
        decreaseFontSize: function() {
            if ($.browser.msie) {
                this.ec("fontSize", false, this.qc("fontSize") - 1);
            } else if ($.browser.safari) {
                this.getRange().surroundContents($(this.tagIframe[0].contentWindow.document.createElement("span")).css("font-size", "smaller")[0]);
            } else {
                this.ec("decreaseFontSize", false, "small");
            }
        },

        forecolor: function(c) {
        	if(opts.forecolor) {
        		opts.forecolor();
        	} else {
        		this.ec("foreColor", false, c || prompt("Enter HTML Color:", "#"));
        	}
        },

        formatBlock: function(v) {
            this.ec("formatblock", false, v || null);
        },

        showHTMLView: function() {
            this.updatetagTextarea();
            this.tagTextarea.show();
            this.htmlarea.hide();
            this.editor.body.style.display = "none"; 
        },
        hideHTMLView: function() {
            this.updateHtmlArea();
            this.tagTextarea.hide();
            this.htmlarea.show();
            this.editor.body.style.display = "block"; 
        },
        toggleHTMLView: function() {
            (this.tagTextarea.is(":hidden")) ? this.showHTMLView() : this.hideHTMLView();
        },

        toHtmlString: function() {
            return this.editor.body.innerHTML;
        },
        toString: function() {
            return this.editor.body.innerText;
        },

        updatetagTextarea: function() {
            this.tagTextarea.val(this.toHtmlString());
        },
        updateHtmlArea: function() {
            this.editor.body.innerHTML = this.tagTextarea.val();
        },
        switchFocus: function(focusIn) {
            switch (focusIn) {
                case "dialog":
                    $('.ceibooEditor-dialog').show();    
                    $('.ceibooEditor-editor').hide();    
                    $(".ceibooEditor-toolbar").hide();
                    //$(".ceibooEditor-toolbarbottom").hide();
                    $('.ceibooEditor-wait').hide();
                    break;
                case "wait":
                    $('.ceibooEditor-dialog').hide();
                    $('.ceibooEditor-editor').hide();
                    $(".ceibooEditor-toolbar").hide();
                    //$(".ceibooEditor-toolbarbottom").hide();
                    $('.ceibooEditor-wait').show();
                    break;
                case "editor":
                    $('.ceibooEditor-dialog').hide();
                    $('.ceibooEditor-editor').show();
                    $(".ceibooEditor-toolbar").show();
                    //$(".ceibooEditor-toolbarbottom").show();
                    $('.ceibooEditor-wait').hide();
                    break;
            }
        },
        insertarTC: function (id, sUrl, que) {
            if(id)
            {
                var thisClass = this;
                $.post(sUrl).done(function (data) {
                    $('.ceibooEditor-dialog').html(data);
                    thisClass.switchFocus("dialog");
                    
                    $('.ceibooEditor-dialog').find('.card').each(function () {
                        var self = this;
                        $(this).click(function () {
                            console.log("aca",this);
                            thisClass.switchFocus("wait");
                            var dataItem = $(self).attr("data-value");
                            var dataCaption = $(self).attr("data-title");
                            var html = '<blockquote><p><b>También te puede interesar:</b></p><p><a href="' + dataItem + '">' + dataCaption + '</a></p> <blockquote><p><br></p>';
                            thisClass.switchFocus("editor");
                            thisClass.ec('insertHTML', true, html);
                            return true;

                        });
                    });
                    
                });
            } else {
                var q=que;
                swal({
                    title: 'Imposible!',
                    text: 'No tengo ' + q +' relacionada para nuevas noticias',
                    type: 'error',
                    confirmButtonClass: "btn btn-info",
                    buttonsStyling: false
                });
            }
        },
        categories: function () { 
            var idcategory = $(this.tagTextarea).attr("data-idcategory");
            var sUrl=hostadmin + "ajaxFiles/categories/" + idcategory + "/";
            this.insertarTC(idcategory, sUrl, "categoria");
        },
        trends: function () {
            var idtrend=$(this.tagTextarea).attr("data-idtrend");
            var sUrl=hostadmin + "ajaxFiles/trends/" + idtrend + "/";
            this.insertarTC(idtrend, sUrl,"tendencia");
        },
        relations: function (url) {
            var thisClass = this;
            var sWidth = "600px";
            swal({
                title: 'Buscar noticia relacionada',
                html:
                    '<input id="swal-input1" style="width:80%; margin:0px 2%" >' +
                    '<input id="swal-input2" value="' + sWidth + '" style="width:14%; margin:0px 2% 0px 0px">',
                focusConfirm: false,
                showCancelButton: true,
                confirmButtonText: 'Buscar',
                confirmButtonColor: '#dd4b39',
                preConfirm: function () {
                    texto = $('#swal-input1').val();
                    sWidth = $('#swal-input2').val();
                    if (texto == "") {
                        return false;
                    }
                    return $.post(hostadmin + "ajaxFiles/relations/" + texto + "/").done(function (data) {
                        $('.ceibooEditor-dialog').html(data);
                        return true;
                    })
                },
                allowOutsideClick: () => !swal.isLoading()
            }).then((result) => {
                if (result) {
                    thisClass.switchFocus("dialog");

                    $('.ceibooEditor-dialog').find('.card').each(function () {
                        var self = this;
                        $(this).click(function () {
                            thisClass.switchFocus("wait");
                            var dataItem = $(self).attr("data-value");
                            var dataCaption = $(self).attr("data-title");
                            var html = '<blockquote><p><b>También te puede interesar:</b></p> <p><a href="' + dataItem + '">' + dataCaption + '</a></p><blockquote><p>&nbsp;</p>';
                            thisClass.switchFocus("editor");
                            thisClass.ec('insertHTML', true, html);
                            return true;

                        });
                    });
                }
            });
        },
        audio: function () { 
            this.media("audio");
        },
        video: function () {
            this.media("video");
        },
        media: function (modo) {
            var data = new FormData();
            var thisClass = this;
            var sWidth = "600px";
            var file = null;
            swal({
                title: 'Insertar ' + modo,
                html:
                    '<input id="swal-input1" type="file" style="width:100%; margin:0px 2%" >' +
                    '<input id="swal-input3" type="text" style="width:80%; margin:5px 2%" placeholder="Texto para pie del audio/video" >' +
                    '<input id="swal-input2" value="' + sWidth + '" style="width:10%; margin:5px 2% 5px 0px">',
                focusConfirm: false,
                showCancelButton: true,
                confirmButtonText: 'Insertar',
                confirmButtonColor: '#dd4b39',
                allowOutsideClick: () => !swal.isLoading()
            }).then(function () {
                //file = $('#swal-input1')[0];
                file = document.getElementById('swal-input1').files[0];
                sWidth = $('#swal-input2').val();
                var dataCaption = $('#swal-input3').val();
                data.append('tmpmedia', file);
                thisClass.switchFocus("wait");
                $.ajax({
                    type: "POST",
                    url: hostadmin + "saveMediaFromPostFile/",
                    data: data, // Data sent to server, a set of key/value pairs (i.e. form fields and values)
                    contentType: false,       // The content type used when sending data to the server.
                    cache: false,             // To unable request pages to be cached
                    processData: false,
                    success: function (data) {
                        if(modo=="audio") {
                            html = '<audio controls><source src="' + data.trim() + '" type="audio/mp3" /></audio><p>'+dataCaption+'</p><p>&nbsp;</p>';
                        } else {
                            html = '<video controls><source src="' + data.trim() + '" type="video/mp4" /></video><p>' + dataCaption + '</p><p>&nbsp;</p>';
                        }
                        thisClass.switchFocus("editor");
                        thisClass.ec('insertHTML', true, html);
                        return true;
                    },
                    error: function (e) {
                        if (e.statusText === 'timeout') {
                            console.log('Tiempo de espera agotado');
                        }
                        else {
                            console.log(e.statusText);
                        }
                    },
                    timeout: 50000
                });
            });
        },
        image: function() {
            var data = new FormData();
            var thisClass = this;
            var sWidth = "600px";
            var file = null;
            swal({
                title: 'Insertar Imágen',
                html:
                '<input id="swal-input1" type="file" style="width:100%; margin:0px 2%" >' +
                '<input id="swal-input3" type="text" style="width:80%; margin:5px 2%" placeholder="Texto para pie de foto" >' +
                '<input id="swal-input2" value="' + sWidth + '" style="width:10%; margin:5px 2% 5px 0px">',
                focusConfirm: false,
                showCancelButton: true,
                confirmButtonText: 'Insertar',
                confirmButtonColor: '#dd4b39',
                allowOutsideClick: () => !swal.isLoading()
            }).then(function() {
                    //file = $('#swal-input1')[0];
                file = document.getElementById('swal-input1').files[0];
                    sWidth = $('#swal-input2').val();
                    var dataCaption = $('#swal-input3').val();
                    data.append('urlimage', file);
                    thisClass.switchFocus("wait");
                    $.ajax({
                        type: "POST",
                        url: hostadmin + "saveImagesFromPostFile/",
                        data: data, // Data sent to server, a set of key/value pairs (i.e. form fields and values)
                        contentType: false,       // The content type used when sending data to the server.
                        cache: false,             // To unable request pages to be cached
                        processData: false,
                        success: function (data) {
                            html = '<figure class="image"><img src="' + data + '" alt="' + dataCaption + '" class="entry-thumbnail" width="' + sWidth + '"><figcaption>' + dataCaption + '</figcaption></figure><p>&nbsp;</p>';
                            console.log(html);
                            thisClass.switchFocus("editor");
                            thisClass.ec('insertHTML', true, html);
                            return true;
                        },
                        error: function (e) {
                            if (e.statusText === 'timeout') {
                                console.log('Tiempo de espera agotado');
                            }
                            else {
                                console.log(e.statusText);
                            }
                        },
                        timeout: 20000
                    });
            });
        },
        google: function (url) {
            var thisClass = this;
            var sWidth = "600px";
            swal({
                title: 'Buscar Imágen en Google',
                html:
                    '<input id="swal-input1" style="width:80%; margin:0px 2%" >' +
                    '<input id="swal-input2" value="' + sWidth + '" style="width:14%; margin:0px 2% 0px 0px">',
                focusConfirm: false,
                showCancelButton: true,
                confirmButtonText: 'Buscar',
                confirmButtonColor: '#dd4b39',
                preConfirm: function () {
                    texto = $('#swal-input1').val();
                    sWidth = $('#swal-input2').val();
                    if (texto == "") {
                        return false;
                    }
                    return $.post(hostadmin + "ajaxFiles/googleimages/" + texto + "/").done(function (data) {
                        $('.ceibooEditor-dialog').html(data);
                        return true;
                    })
                },
                allowOutsideClick: () => !swal.isLoading()
            }).then((result) => {
                if (result) {
                    thisClass.switchFocus("dialog");

                    $('.ceibooEditor-dialog').find('.card').each(function () {
                        var self = this;
                        $(this).click(function () {
                            thisClass.switchFocus("wait");
                            var dataItem = $(self).attr("data-value");
                            var dataCaption = $(self).attr("data-title");
                            var html = '';
                            $.post(hostadmin + "saveImagesDirect/", { urlimagen: dataItem }).
                                done(function (data) {
                                    html = '<figure class="image"><img src="' + data + '" alt="' + dataCaption + '" class="entry-thumbnail" width="' + sWidth + '"><figcaption>' + dataCaption + '</figcaption></figure><p><br></p>';
                                    console.log(html);
                                    thisClass.switchFocus("editor");
                                    thisClass.ec('insertHTML', true, html);
                                    return true;
                                }).fail(function () {
                                    thisClass.switchFocus("editor");
                                    return true;
                                });
                                
                        });
                    });
                }
            });
        },
        insertIframe: function (que) {
            var thisClass = this;
            swal({
                title: "Ingrese el "+que+"!",
                html: "<textarea id='swal-input1' cols='50' rows='3'></textarea>",
                showCancelButton: true,
                closeOnConfirm: false,
                showLoaderOnConfirm: true,
                confirmButtonColor: '#dd4b39',
                confirmButtonText: 'Insertar',
                animation: "slide-from-top",
                inputPlaceholder: "Write something"
            }).then((result) => {
                if (result) {
                    if(que=="pin") {
                        var html = '<a data-pin-do="embedPin" href="' + $('#swal-input1').val()+'"></a>';
                    } else {
                        var html = $('#swal-input1').val();
                    }

                    html +="<p>&nbsp;</p>";
                    thisClass.ec('insertHTML', true, html);
                    return true;
                } else {
                    return false;
                }
            });
        },
        pinterest: function () { this.insertIframe("pin"); },
        twitter: function () { this.insertIframe("tweet"); },
        facebook: function () { this.insertIframe("post"); },
        youtube: function (url) {
            var thisClass = this;
            var sWidth = "600px";
                swal({
                    title: 'Buscar video en Youtube',
                    html:
                        '<input id="swal-input1" style="width:80%; margin:0px 2%" >' +
                        '<input id="swal-input2" value="' + sWidth +'" style="width:14%; margin:0px 2% 0px 0px">',
                    focusConfirm: false,
                    showCancelButton: true,
                    confirmButtonText: 'Buscar',
                    confirmButtonColor: '#dd4b39',
                    preConfirm: function () {
                        texto=$('#swal-input1').val();
                        sWidth=$('#swal-input2').val();
                        if(texto=="")
                        {
                            return false;
                        }
                        return $.post(hostadmin + "ajaxFiles/youtubevideo/" + texto + "/").done(function (data) {
                            $('.ceibooEditor-dialog').html(data);
                            return true;
                        })
                    },
                    allowOutsideClick: () => !swal.isLoading()
                }).then((result) => {
                    if (result) {
                        thisClass.switchFocus("dialog");

                        $('.ceibooEditor-dialog').find('.card').each(function () {
                            var self = this;
                            $(this).click(function () {
                                thisClass.switchFocus("wait");
                                var dataItem = $(self).attr("data-value");
                                var dataCaption = $(self).attr("data-title");
                                var html = '<figure class="op-interactive"><iframe class="no-margin" src="https://www.youtube.com/embed/' + dataItem + '" width="' + sWidth + '" height="' + (parseInt(sWidth)*3/4) + '" ></iframe><figcaption>' + dataCaption + '</figcaption></figure><p>&nbsp;</p>';
                                thisClass.switchFocus("editor");
                                thisClass.ec('insertHTML', true, html);

                            });
                        });
                    }
                });
        }

    };
    JCeibooEditor.fn.init.prototype = JCeibooEditor.fn;

    JCeibooEditor.defaultOptions = {
        toolbar: [
        ["blockquote","bold", "italic", "underline", "strikethrough", "subscript", "superscript"],
        ["cut", "copy", "paste"],
        /*["increasefontsize", "decreasefontsize"],*/
        ["orderedlist", "unorderedlist"],
        ["indent", "outdent"],
        ["justifyleft", "justifycenter", "justifyright"],
        ["horizontalrule"],
        ["h1", "h2", "h3", "h4", "h5", "h6"],
        //["fontfamily"],
        ["html"],["changetofullscreen"]
    ],
    /*
        toolbarbottom: [["link", "relations","trends", "categories", "image","audio","video","google","youtube","twitter","facebook","pinterest"]],*/
        useSingleQuotes: true,
        css: null,
        toolbarText: {
            blockquote: "Parrafo resaltado",
            bold: "Negrita", italic: "Itálica", underline: "Subrayada", strikethrough: "Strike-Through",
            cut: "Cortar", copy: "Copiar", paste: "Pegar",
            h1: "Título 1", h2: "Título 2", h3: "Título 3", h4: "Título 4", h5: "Título 5", h6: "Título 6", p: "Párrafo",
            indent: "Margen", outdent: "Outdent", horizontalrule: "Linea Horizontal",
            justifyleft: "Alinear izquierda", justifycenter: "Centrar", justifyright: "Alinear derecha",
            increasefontsize: "Increase Font Size", decreasefontsize: "Decrease Font Size", forecolor: "Text Color",
            link: "Enlace", unlink: "Remove Link", image: "Insertar Imagen", audio: "Insertar Audio", video: "Insertar Video", relations: "Enlace relacionado", trends: "Tendencias relacionadas", google: "Imagen de Google", categories: "Categorias relacionadas",
            youtube: "Video de Youtube", twitter: "Twitter", facebook: "Facebook", pinterest: "Pinterest",
            orderedlist: "lista ordenada", unorderedlist: "lista",
            subscript: "Subscript", superscript: "Superscript",
            changetofullscreen: "Cambiar a pantalla completa",
            //fontfamily:"Font Family",
            html: "Ver código HTML"
        },
        toolbarIcon: {
            blockquote: "fas fa-quote-left", bold: "fas fa-bold", italic: "fas fa-italic", underline: "fas fa-underline", strikethrough: "fas fa-strikethrough",
            cut: "fas fa-cut", copy: "fas fa-copy", paste: "fas fa-paste",
            h1: "fas fa-dice-one", h2: "fas fa-dice-two", h3: "fas fa-dice-three", h4: "fas fa-dice-four", h5: "fas fa-dice-five", h6: "fas fa-dice-six", p: "fas fa-title",
            indent: "fas fa-indent", outdent: "fas fa-outdent", horizontalrule: "fas fa-window-minimize",
            justifyleft: "fas fa-align-left", justifycenter: "fas fa-align-center", justifyright: "fas fa-align-right",
            increasefontsize: "fas fa-size", decreasefontsize: "fas fa-text_fields", forecolor: "fas fa-color_text",
            link: "fas fa-link", unlink: "unlink", image: "fas fa-image", audio: "fas fa-volume-up", video: "fas fa-video", relations: "fab fa-rev", trends: "fas fa-clock", google: "fab fa-google",
            youtube: "fab fa-youtube", twitter: "fab fa-twitter", facebook: "fab fa-facebook", pinterest: "fab fa-pinterest", categories: "fas fa-first-aid",
            orderedlist: "fas fa-list-ol", unorderedlist: "fas fa-list-ul", 
            subscript: "fas fa-subscript", superscript: "fas fa-superscript",
            changetofullscreen: "fas fa-square-full",
            //fontfamily:"Font Family",
            html: "fas fa-code"
        }
    };
    var privateFunctions = {
        toolbarButtons: {
            strikethrough: "strikeThrough", orderedlist: "orderedList", unorderedlist: "unorderedList",
            horizontalrule: "insertHorizontalRule",
            justifyleft: "justifyLeft", justifycenter: "justifyCenter", justifyright: "justifyRight",
            increasefontsize: "increaseFontSize", decreasefontsize: "decreaseFontSize",
            html: function(btn) {
                this.toggleHTMLView();
            }
        },
        initEditor: function(options, container) {
            var edit = this.editor = this.tagIframe[0].contentWindow.document;
            var textedit = edit.getElementsByTagName('body');
            var focused = false;
            edit.designMode = 'on';
            edit.open();
            //edit.write("<textarea style='width:100%; height:100%;'>"+this.tagTextarea.val()+"</textarea>");
            document.execCommand("DefaultParagraphSeparator", true, 'p');
            
            if (this.tagTextarea.val() === "") {
                edit.write('<p><br></p>');
            } else {
                edit.write(this.tagTextarea.val());
            }
            edit.close();

            if (options.css) {
            	for(i=0;i<options.css.length;i++) {
        			var e = edit.createElement('link'); e.rel = 'stylesheet'; e.type = 'text/css'; e.href = options.css[i]; edit.getElementsByTagName('head')[0].appendChild(e);
        		}
            }
/*            var e = edit.createElement('script'); e.async = ''; e.charset = 'utf-8'; e.src = "https://platform.twitter.com/widgets.js"; edit.getElementsByTagName('head')[0].appendChild(e);
            var e = edit.createElement('script'); e.async = ''; e.charset = 'utf-8'; e.src = "//assets.pinterest.com/js/pinit.js"; edit.getElementsByTagName('head')[0].appendChild(e);
*/
            //$(edit.getElementsByTagName('body')[0]).html("<p></p>");
            if (options.selector) {
            	for(i=0;i<options.selector.length;i++) {
        			$(textedit).addClass(options.selector[i]);
            	}
            }
            
            $(textedit).keyup(function(event) { 
               // console.log("keyup", event);
            	privateFunctions.controlKeys(event);
            	/*********************************************************************/
            	/*********************************************************************/
            		/* aca */
            	/*********************************************************************/
            	/*********************************************************************/
            	if(event.keyCode===9 && !focused) { //alert($(container).next().next().next().html()); 
            		
            	}
            	
            	if(focused) { focused=false; }
            });
            
            $(container).focusin(function(event) { 
            	$(textedit).focus();
            	focused=true;
            	event.stopPropagation();
            	});
            $(textedit).focusin(function(event) {
                $(container).css("border","1px solid #d93732");
            });
            $(textedit).focusout(function(event) { 
                $(container).css("border","1px solid #d5d5d5");
           	});

        },
        initToolBar: function(options,istop=true) {
            var that = this;

            var menuItem = function(className, altText, action) {
                return $("<li/>").append($("<a/>").attr("title", altText).append($("<i class='" + className + "'/>")).click(function () { action.call(that, $(this)); }));
                
            };

            function addButtons(arr) {
                
                for (var i = 0; i < arr.length; i++) {
                    var e = arr[i];
                    if ((typeof (e)).toLowerCase() === "string") {
                        if (e === "|") {
                            ul.append($('<li class="separator"/>'));
                        } else {
                            var f = (function(e) {
                                var m = privateFunctions.toolbarButtons[e] || e;
                                if ((typeof (m)).toLowerCase() === "function") {
                                    return function(btn) { m.call(this, btn); };
                                } else {
                                    return function() { that[m](); that.editor.body.focus(); };
                                }
                            })(e.toLowerCase());
                            var t = options.toolbarText[e.toLowerCase()];
                            var icon = options.toolbarIcon[e.toLowerCase()];
                            ul.append(menuItem(icon || e.toLowerCase(), t || e, f));
                        }
                    } else {
                        ul.append(menuItem(e.css, e.text, e.action));
                    }
                }
            };
            if(istop===true) {
                var ul = $("<ul/>").appendTo(that.toolbar);
                if (options.toolbar.length !== 0 && privateFunctions.isArray(options.toolbar[0])) {
                    for (var i = 0; i < options.toolbar.length; i++) {
                        addButtons(options.toolbar[i]);
                        ul.append("<li class='separator'/>");
                    }
                } else {
                    addButtons(options.toolbar);
                }
            } else {
                /*var ul = $("<ul/>").appendTo(that.toolbarbottom);
                if (options.toolbarbottom.length !== 0 && privateFunctions.isArray(options.toolbarbottom[0])) {
                    for (var i = 0; i < options.toolbarbottom.length; i++) {
                        addButtons(options.toolbarbottom[i]);
                        ul.append("<li class='separator'/>");
                    }
                } else {
                    addButtons(options.toolbarbottom);
                }
*/
            }
        },
        controlKeys: function(event) {
        	//if(event.keyCode=="9") {
            //alert(this.editor.attr("id"));//}
            console.log("controlKeys", event);
        },
        attachEditorEvents: function() {
            var t = this;

            var fnHA = function() {
                t.updateHtmlArea();
            };

            
            this.tagTextarea.click(fnHA).
            keyup(fnHA).
            keydown(fnHA).
            mousedown(fnHA).
            blur(fnHA);
            
            var fnTA = function() {
                t.updatetagTextarea();
            };

/*            this.editor.click(fnTA).
                keyup(fnTA).
                keydown(fnTA).
                mousedown(fnTA).
                blur(fnTA);
*/
            $(this.editor.body).click(fnTA).
                keyup(fnTA).
                keydown(fnTA).
                mousedown(fnTA).
                blur(fnTA);

            /* $(this.editor.body).focusin(function(event) {
            	alert("aca");
            }*/
            $('form').submit(function() { t.toggleHTMLView(); t.toggleHTMLView(); });


        },
        isArray: function(v) {
            return v && typeof v === 'object' && typeof v.length === 'number' && typeof v.splice === 'function' && !(v.propertyIsEnumerable('length'));
        },
        strip_tags: function (html) {
    		if(arguments.length < 3) {
    			html=html.replace(/<\/?(?!\!)[^>]*>/gi, '');
    		} else {
    			var allowed = arguments[1];
    			var specified = eval("["+arguments[2]+"]");
    			if(allowed){
    				var regex='</?(?!(' + specified.join('|') + '))\b[^>]*>';
    				html=html.replace(new RegExp(regex, 'gi'), '');
    			} else{
    				var regex='</?(' + specified.join('|') + ')\b[^>]*>';
    				html=html.replace(new RegExp(regex, 'gi'), '');
    			}
    		}
     
    		var clean_string = html;
     
    		return clean_string;
    	},
    	initRndEmelentId: function(toNumber) {
    		toNumber=(toNumber ? toNumber : "100");
    		return Math.floor(Math.random()*toNumber);
    	}
    };
})(jQuery);