<?php
Class TEvents extends TTable
{
    static private $TControl=NULL;

    public function __construct(TControl $TControl)
    {
       parent::__construct($TControl);
       self::$TControl = $TControl;
       
       $this->table="spm_news_events";
       $this->order="idevent";
       $this->sort="DESC";
       $this->list="idevent,title,state";
       $this->listNames=array("IDevent","Título","Activo");
       $this->primaryKey="idevent";
    }

    public function getDataPack($aParam=false)
    {
        $bigData=parent::getDataPack($aParam);
        $bigData["areas"]=self::$TControl->TAreas->getOrdByID(true);
        $bigData["trends"]=self::$TControl->TTrends->getOrdByID(true);
        $bigData["places"]=self::$TControl->TPlaces->getOrdByID(true);
        
        $bigData["footer"]=array("editor","dropify","initDatetimepickers");
        if(isset($bigData["record"]["idevent"]))
        {
            $idEvent=$bigData["record"]["idevent"];
            $consulta="SELECT * FROM spm_news_eventsxday WHERE idevent='".$idEvent."'";
            $aData=self::$TControl->TDb->getArray($consulta);
            $bigData["days"]=[];
            foreach ($aData as $rData) {
                $id=$rData["position"];
                $bigData["days"][$id]=$rData;
            }
        } else {
            $bigData["days"]=[];
        }
        
        return $bigData;
    }

    public function getLasts()
    {
        $consulta="SELECT d.position,d.startday,d.endday,d.idplace,d.iface,e.*,p.name as placename, a.title as areatitle, t.title as trendtile FROM spm_news_eventsxday AS d
        LEFT JOIN spm_news_events as e ON d.idevent=e.idevent
        LEFT JOIN spm_info_places as p ON d.idplace=p.idplace
        LEFT JOIN spm_info_areas as a ON e.idarea=a.idarea
        LEFT JOIN spm_news_trends as t ON e.idtrend=t.idtrend
        WHERE startday>now()";
        $aData=self::$TControl->TDb->getArray($consulta);
        $aDataDev=[];
        $lastEvent=0;
        foreach($aData as $rData)
        {
            if($rData["idevent"]!=$lastEvent)
            {
                $aDataDev[$rData["idevent"]]=$rData;
                $i=0;
            } else {
                $aDataDev[$rData["idevent"]]["next"][$i]=[];
                $aDataDev[$rData["idevent"]]["next"][$i]["startday"]=$rData["startday"];
                $aDataDev[$rData["idevent"]]["next"][$i]["endday"]=$rData["endday"];
                $aDataDev[$rData["idevent"]]["next"][$i]["idplace"]=$rData["idplace"];
                $i++;
            }
            $lastEvent=$rData["idevent"];
        }

        return $aDataDev;
    }

   public function set($aData) 
    {
        $sFileImage=false;
        if(isset($_FILES["tmpimage"]) && !empty($_FILES["tmpimage"]["name"])) {
            self::$TControl->TUpload->setPath("posts/");
            self::$TControl->TUpload->setBigSize(array("image_x"=>1200,"image_y"=>628, "image_resize"=>true, "image_ratio_crop"=>true ));
            self::$TControl->TUpload->setNormalSize(array("image_x"=>480,"image_y"=>300, "image_resize"=>true, "image_ratio_crop"=>true ));
            $aData=$this->setFile($aData);
        }
        parent::set($aData);
        if(isset($aData["idevent"])) {
            $id=$aData["idevent"];
        } else {
            $id=self::$TControl->TDb->Insert_ID();
        }
        $i=0;
        foreach($aData["startday"] as $startday) {
            if(!empty($startday)) {
                $consulta = "REPLACE spm_news_eventsxday SET idevent='".$id."', position='".$i."', startday='".$_POST["startday"][$i]."', endday='".$_POST["endday"][$i]."', idplace='".$_POST["idplace"][$i]."', iface='".$_POST["iface"][$i]."', active='on'";
                self::$TControl->TDb->execute($consulta);
            }
            $i++;
        }
    }

    public function switchPublicar($idKey,$switch)
    {
        $consulta = "UPDATE ".$this->table." SET state='".$switch."' WHERE ".$this->primaryKey."='".$idKey."'";
        //echo $consulta;
        self::$TControl->TDb->execute( $consulta );
    }

    public function switchEnviar($idKey)
    {
        $consulta = "UPDATE ".$this->table." SET iface='ok', state='on' WHERE ".$this->primaryKey."='".$idKey."'";
        //echo $consulta;
        self::$TControl->TDb->execute( $consulta );
    }
    
   
}
?>