<?php
Class TPosts extends TTable
{
    static private $TControl=NULL;

    public function __construct(TControl $TControl)
    {
       parent::__construct($TControl);
       self::$TControl = $TControl;
       
       $this->table="spm_news_posts";
       $this->order="idpost";
       $this->sort="DESC";
       $this->list="idpost,title,state";
       $this->listNames=array("IDPost","Título","Activo");
       $this->primaryKey="idpost";
    }

    public function getDataPack($aParam=false)
    {
        $bigData=parent::getDataPack($aParam);
        //$bigData["users"]=self::$TControl->TUsers->getOrdByID(true);
        $bigData["areas"]=self::$TControl->TAreas->getOrdByID(true);
        $bigData["trends"]=self::$TControl->TTrends->getOrdByID(true);
        return $bigData;
    }

    public function getLasts($limit=4)
    {
        $consulta="SELECT p.*, a.formality as formality, a.title as areatitle, t.title as trendtitle FROM ".$this->table." as p 
        LEFT JOIN spm_news_trends as t ON p.idtrend=t.idtrend
        LEFT JOIN spm_info_areas as a ON p.idarea=a.idarea WHERE 1 ORDER BY p.idpost DESC LIMIT 0,".$limit;
        $aData=self::$TControl->TDb->getArray($consulta);
        return $aData;
    }


   public function set($aData) 
    {
        $sFileImage=false;
        if(isset($_FILES["tmpimage"]) && !empty($_FILES["tmpimage"]["name"])) {
            self::$TControl->TUpload->setPath("posts/");
            self::$TControl->TUpload->setBigSize(array("image_x"=>1200,"image_y"=>628, "image_resize"=>true, "image_ratio_crop"=>true ));
            self::$TControl->TUpload->setNormalSize(array("image_x"=>480,"image_y"=>300, "image_resize"=>true, "image_ratio_crop"=>true ));
            $aData=$this->setFile($aData);

        } else if(isset($aData["urlimage"])) {
            if(strpos($aData["urlimage"], "all/uploads/")===false)
            {
                self::$TControl->TUpload->setPath("posts/");
                self::$TControl->TUpload->setBigSize(array("image_x"=>1200,"image_y"=>628, "image_resize"=>true, "image_ratio_crop"=>true ));
                self::$TControl->TUpload->setNormalSize(array("image_x"=>480,"image_y"=>300, "image_resize"=>true, "image_ratio_crop"=>true ));
    
                /*$sFileImage=self::$TControl->TUpload->UploadImageFromUrl($aData["urlimage"],self::$TControl->TLoggedon->codename."/uploads/posts/","uploads/posts/",$aVerotAttrib,$sNameSufix."_main");
                $sFileImage_mobile=self::$TControl->TUpload->UploadImageFromUrl($aData["urlimage"],self::$TControl->TLoggedon->codename."/uploads/posts/","uploads/posts/",$aVerotAttribMobile,$sNameSufix."_mobile");*/
            }
        }

        parent::set($aData);
    }

    public function formatUrl($id,$title)
    {
        return _TB_HOST."noticia/".$id."/".strtolower(str_replace(" ","_",self::$TControl->TWords->sanear_string($title)))."/";
    }

    
   
}
?>