<?php
Class tTable
{
    
    static private $TControl=NULL;
    protected $table=NULL;
    protected $primaryKey=NULL;
    public $order=NULL;
    public $sort="ASC";
    public $list=NULL;
    public $listNames=NULL;
    public $hasIdSite=false;
    protected $aFields=array();

    public function __construct(TControl $TControl)
    {
        self::$TControl = $TControl;
        /* 
        
        Llenar estos campos en la clase principal

        $this->table="ver_grupos";
        $this->order="idgrupo";
        $this->list="idgrupo, titulo, activo";
        $this->listNames=array("Idgrupo", "Titulo", "Activo");
        $this->primaryKey="idgrupo";

       */
       
    }

    public function getDataPack($aParam=false) 
    {
        // Llenar en la funcion principal
        
        $rData=(isset($aParam[1])?$this->getRecord($aParam[1]):false);
        if(is_array($rData)) {
            return array("record"=>$rData[0]);
        } else {
            return array("record"=>false);
        }
    }

    public function getFields()
    {
        $sql = "select column_name from information_schema.columns WHERE TABLE_NAME='".$this->table."'";
        $aResult = self::$TControl->TDb->getArray($sql);
        $aFields = array();
        foreach ($aResult as $key => $rDefault) {
            $aFields[$key] = $rDefault["column_name"];
        }
        return $aFields;
    }

    public function getPrimaryKey()
    {
        return $this->primaryKey;
    }

    public function getByKey($id)
    {
        return $this->get($this->primaryKey."='".$id."'");
    }

    public function get($where=false, $limit=false)
    {
        return $this->getThis("*",$where, $limit);
    }
    
    public function getList($where=false, $limit=false)
    {
       $aResultado = $this->getThis($this->list,$where, $limit);
       return $aResultado;            
    }
    
    public function getThis($fields="*", $where=false, $limit=false)
    {
       $consulta = "SELECT ".$fields." FROM ".$this->table." ".($where?" WHERE ".$where:'')." ORDER BY ".$this->order." ".$this->sort.($limit?" LIMIT ".$limit:'');
       $aResultado = self::$TControl->TDb->getArray( $consulta );
       
       if(isset($_GET["debug"])) { echo $consulta; if($_GET["debug"]=="1") { exit(0); } }
       
       if(is_array($aResultado))
       {
            foreach ($aResultado as $key => $rResultado) 
            {
                if(is_array($rResultado)) 
                {
                    foreach ($rResultado as $key2 => $value) 
                    {
                        if(is_numeric($value)) 
                        {
                            $aResultado[$key][$key2]=$value;
                        } elseif($key2=="jsongetdata") {
                            $aResultado[$key][$key2]=$value;
                        } elseif($key2=="jsondata") {
                            $aResultado[$key][$key2]=self::$TControl->TWords->decodeTitle($value,'"');
                        } else {
                            //$aResultado[$key][$key2]=self::$TControl->TWords->decodeTitle($value);
                            $aResultado[$key][$key2]=$value;
                        }
                   }
                }
            }
            return $aResultado;            
        } else {
            return $aResultado;
        }

    }
    
    public function getOrdBy($field=false,$where=false) 
    {
        $field=(isset($field) && $field!=false)?$field:$this->primaryKey;
        $aData=$this->get($where);
    	$aDataDev=array();
    	foreach ($aData as $rData) {
    		$id=$rData[$field];
    		$aDataDev[$id]=$rData;
    	}
    	return $aDataDev;
    }

    public function getOrdByID($where=false) 
    {
        $aData=$this->get($where);
    	$aDataDev=array();
    	foreach ($aData as $rData) {
    		$id=$rData[$this->primaryKey];
    		$aDataDev[$id]=$rData;
    	}
    	return $aDataDev;
    }

    public function set($aData)
    {
        $this->aFields=$this->getFields();
        
        if(isset($aData[$this->primaryKey]))
        {
            $consulta = "UPDATE ".$this->table." SET ";
        } else {
            $consulta = "INSERT INTO ".$this->table." SET ";
        }

        $lastconsulta='';
        foreach ($aData as $key => $value) {
            if(isset($aData[$this->primaryKey]) && $key==$this->primaryKey )
            {
                $lastconsulta = " WHERE ".$this->primaryKey."='".$value."' ";
            } else {
                if(in_array($key, $this->aFields)) {
                    if($key=="password")
                    {
                        $consulta .= $key."='".MD5($value)."', ";
                    } elseif($key=="jsongetdata") {
                        $consulta .= $key."='".$value."', ";
                    } else {
                        $consulta .= $key."='".htmlspecialchars(addslashes($value))."', ";
                    }
                }
            }
        }

        $consulta=substr($consulta, 0, -2).$lastconsulta;
        if(isset($_GET["debug"]))
        {
            echo $consulta;
            if($_GET["debug"]=="0") {
                exit(0);
            }
        }
        return self::$TControl->TDb->execute( $consulta );

    }

    public function setFileFromInput($sInputFile="tmpimage",$sFolder=false,$aVerotAttrib=false)
    {
        if($_FILES[$sInputFile]["name"]!='') 
        {
            if(!$sFolder) 
            {
                $sFolder=self::$TControl->TLoggedon->codename."/uploads/posts/";
                $sFolderURL="/uploads/posts/";
            }
            $sFileName=self::$TControl->TUpload->UploadImageFromInput($sInputFile,$sFolder,$sFolderURL,$aVerotAttrib);
            return $sFileName;
        } else {
            return false;
        }
    }


    public function setFileFromUrl($sInputFile="tmpimage",$sFolder=false,$aVerotAttrib=false)
    {
        if(!$sFolder) 
        {
            $sFolder=self::$TControl->TLoggedon->codename."/uploads/posts/";
            $sFolderURL="/uploads/posts/";
        }
        $sFileName=self::$TControl->TUpload->UploadImageFromUrl($sInputFile,$sFolder,$sFolderURL,$aVerotAttrib);
        return $sFileName;
    }

    public function setFile($aData)
    {
        $aData['tmpimage']=str_replace("_b_", "", $aData['tmpimage']);
        $aData['tmpimage']=str_replace("_n_", "", $aData['tmpimage']);
        $aData['image']=self::$TControl->TUpload->UploadImage("tmpimage");
        return $aData;
    }
    
    public function setFileDirectFromUrl($aData)
    {
        $aData['urlimagen']=str_replace("_b_", "", $aData['urlimagen']);
        $aData['urlimagen']=str_replace("_n_", "", $aData['urlimagen']);
        $aData['imagen']=self::$TControl->TUpload->UploadDirectImageFromUrl($aData['urlimagen']);
        return $aData;
    }


    public function getAll()
    {
        return $this->get(); 
    }

    public function getRecord($idKey)
    {
       return $this->get($this->primaryKey."='".$idKey."'");
    }

    public function getRecordBy($field,$key)
    {
       return $this->get($field."='".$key."'");
    }
    
    public function getActives()
    {
        return $this->get("active='on'"); 
    }
    
    public function getInactives()
    {
        return $this->get("active='off'"); 
    }

    public function setActive($idKey)
    {
        $consulta = "UPDATE ".$this->table." SET active='on' WHERE ".$this->primaryKey."='".$idKey."'";
        self::$TControl->TDb->execute( $consulta );
    }
    public function setInActive($idKey)
    {
        $consulta = "UPDATE ".$this->table." SET active='off' WHERE ".$this->primaryKey."='".$idKey."'";
        self::$TControl->TDb->execute( $consulta );
    }
    public function switchActive($idKey,$switch)
    {
        $consulta = "UPDATE ".$this->table." SET active='".$switch."' WHERE ".$this->primaryKey."='".$idKey."'";
        self::$TControl->TDb->execute( $consulta );
    }
    public function switchField($idKey,$field,$value)
    {
        $consulta = "UPDATE ".$this->table." SET ".$field."='".$value."' WHERE ".$this->primaryKey."='".$idKey."'";
        self::$TControl->TDb->execute( $consulta );
    }
    public function delete($idKey)
    {
        $consulta = "DELETE FROM ".$this->table." WHERE ".$this->primaryKey."='".$idKey."'";
        self::$TControl->TDb->execute( $consulta );
    }

}
?>